//---------------------------------------------------------------------------
#include <vcl.h>
#include <math.h>
#pragma hdrstop
#include <stdio.h>
#include <mmsystem.h>
#include <gl\gl.h>
#include "ScrGL.h"
#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "ScrGL"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
double __fastcall rad(double d) {return d*2.0*3.141592/360.0;}
double __fastcall deg(double d) {return d*180.0/3.141592;}

// INVARIANT:
// projection has the frustrum set up, but nothing else
// modelview has nothing
// we don't know what matrix mode we're in

__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{ glAxes=0;
  IsDragging=FALSE;
  mLong=30;
  cLat=20; cLong=0;
  ListBox1->Items->Assign(GLICDList1->Items);
}
__fastcall TForm1::~TForm1()
{ if (glAxes!=0) sglDeleteLists(glAxes,1); glAxes=0;
}
void __fastcall TForm1::PrepareProjection(POINT *pt)
{ sglMatrixMode(GL_PROJECTION);
  sglLoadIdentity();
  if (pt!=NULL)
  { GLint viewport[4]; sglGetIntegerv(GL_VIEWPORT,viewport);
    sgluPickMatrix(pt->x,viewport[3]-pt->y,1,1,viewport);
  }
  double aspect = (GLfloat) Width / Height;
  sgluPerspective( 45.0, aspect, 3.0, 90.0 );
}
void __fastcall TForm1::ScrGL1Resize(TObject *Sender)
{ PrepareProjection(NULL);
}
// DrawCursor corrupts modelview and projection
void __fastcall TForm1::DrawCursor()
{ sglPushAttrib(GL_ENABLE_BIT | GL_VIEWPORT_BIT | GL_TRANSFORM_BIT);
  sglDisable(GL_LIGHTING);
  sglDisable(GL_FOG);
  sglDisable(GL_DEPTH_TEST);
  sglDisable(GL_CULL_FACE);
  sglDisable(GL_BLEND);
  sglMatrixMode(GL_PROJECTION);
  sglPushMatrix();
  sglLoadIdentity();
  sgluOrtho2D(0.0, ScrGL1->Width, 0.0, ScrGL1->Height);
  sglMatrixMode(GL_MODELVIEW);
  sglLoadIdentity();

  POINT pt; GetCursorPos(&pt); POINT ptc=ScrGL1->ScreenToClient(pt);
  int gx = ptc.x, gy = ScrGL1->Height-ptc.y;
  sglDisable(GL_TEXTURE_2D);
  sglColor3f(1.0f, 1.0f, 1.0f);
  sglBegin(GL_TRIANGLES);
  sglVertex2i( gx, gy);
  sglVertex2i( gx + 13, gy - 4);
  sglVertex2i( gx + 4, gy - 13);
  //
  sglVertex2i( gx + 8, gy - 3);
  sglVertex2i( gx + 17, gy - 12);
  sglVertex2i( gx + 12, gy - 17);
  //
  sglVertex2i( gx + 12, gy - 17);
  sglVertex2i( gx + 3, gy - 8);
  sglVertex2i( gx + 8, gy - 3);
  sglEnd();
  //
  sglColor3f(0.1f, 0.22f, 0.4f);
  sglBegin(GL_TRIANGLES);
  sglVertex2i(gx + 1, gy - 1);
  sglVertex2i(gx + 11, gy - 4);
  sglVertex2i(gx + 4, gy - 11);
  //
  sglVertex2i(gx + 8, gy - 5);
  sglVertex2i(gx + 15, gy - 12);
  sglVertex2i(gx + 12, gy - 15);
  //
  sglVertex2i(gx + 12, gy - 15);
  sglVertex2i(gx + 5, gy - 8);
  sglVertex2i(gx + 8, gy - 5);
  sglEnd();

  sglPopMatrix();
  sglMatrixMode(GL_PROJECTION);
  sglPopMatrix();
  sglPopAttrib();
}
void __fastcall TForm1::DrawScene()
{ sglMatrixMode(GL_PROJECTION);
  sglPushMatrix();
  double r=30.0, rLong=rad(cLong), rLat=rad(cLat);
  sgluLookAt(r*cos(rLong)*cos(rLat),r*sin(rLat),r*sin(rLong)*cos(rLat),  0,0,0,  0,1,0);
  sglMatrixMode(GL_MODELVIEW);
  sglLoadIdentity();
  sglRotatef(mLong, 0,1,0);
  sglCallList(glAxes);
  sglMatrixMode(GL_PROJECTION);
  sglPopMatrix();
}

void __fastcall TForm1::ScrGL1GLPaint(TObject *Sender)
{ DrawScene();
  DrawCursor(); // corrupts modelview and projection
  sglFlush();
}

void __fastcall TForm1::ScrGL1GLInit(TObject *Sender)
{ sglClearDepth( 1.0 );
  sglEnable(GL_DEPTH_TEST);
  PrepareProjection(NULL);
  //
  glAxes=sglGenLists(1);
  sglNewList(glAxes, GL_COMPILE);
    sglPushName(1);
    sglColor3d(0.0,0.0,0.1);
    sglBegin(GL_LINES);
      sglVertex3d(0.0, 0.0, -8.0);
      sglVertex3d(0.0, 0.0, 8.0);
      sglVertex3d(0.0, -8.0, 0.0);
      sglVertex3d(0.0, 8.0, 0.0);
      sglVertex3d(-8.0, 0.0, 0.0);
      sglVertex3d(8.0, 0.0, 0.0);
    sglEnd();
    sglPopName();
    sglPushName(2);
    sglColor3d(1.0, 0.0, 0.0);
    sglBegin(GL_QUADS);
      sglVertex3d(5.0, -0.5, -0.5);
      sglVertex3d(5.0, 0.5, -0.5);
      sglVertex3d(5.0, 0.5, 0.5);
      sglVertex3d(5.0, -0.5, 0.5);
    sglEnd();
    sglPopName();
    sglPushName(3);
    sglBegin(GL_QUADS);
      sglColor3d(0.0, 1.0, 0.0);
      sglVertex3d(-0.5, 5.0, -0.5);
      sglVertex3d(-0.5, 5.0, 0.5);
      sglVertex3d(0.5, 5.0, 0.5);
      sglVertex3d(0.5, 5.0, -0.5);
    sglEnd();
    sglPopName();
    sglPushName(4);
    sglBegin(GL_QUADS);
      sglColor3d(0.0, 0.0, 1.0);
      sglVertex3d(-0.5, -0.5, 5.0);
      sglVertex3d(-0.5, 0.5, 5.0);
      sglVertex3d(0.5, 0.5, 5.0);
      sglVertex3d(0.5, -0.5, 5.0);
    sglEnd();
    sglPopName();
  sglEndList();
}



void __fastcall TForm1::FormKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{ switch (Key)
  { case VK_LEFT: cLong-=5; break;
    case VK_RIGHT: cLong+=5; break;
    case VK_UP: cLat+=5; break;
    case VK_DOWN: cLat-=5; break;
    default: return;
  }
  if (cLat<-85) cLat=-85;
  if (cLat>85) cLat=85;
  ScrGL1->Repaint();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::ScrGL1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{ GLuint buf[512]; sglSelectBuffer(512,buf);
  sglRenderMode(GL_SELECT);
  POINT pt; pt.x=X; pt.y=Y; PrepareProjection(&pt);
  sglInitNames();
  DrawScene();
  GLint nhits=sglRenderMode(GL_RENDER);
  PrepareProjection(NULL); // to restore it back how it was
  if (nhits==0) return;
  // otherwise we hit at least one object
  unsigned int z=(unsigned int)-1;
  int *ptr=(int*)buf;
  for (int h=0; h<nhits; h++)
  { int numnames=*ptr; ptr++;
    unsigned int z1=*(unsigned int*)ptr; ptr++;
    /*unsigned int z2=*(unsigned int*)ptr;*/ ptr++;
    if (z1<z) z=z1;
    for (int n=0; n<numnames; n++) ptr++;
  }
  //
  sglMatrixMode(GL_PROJECTION);
  sglPushMatrix();
  double r=30.0, rLong=rad(cLong), rLat=rad(cLat);
  sgluLookAt(r*cos(rLong)*cos(rLat),r*sin(rLat),r*sin(rLong)*cos(rLat),  0,0,0,  0,1,0);
  sglMatrixMode(GL_MODELVIEW);
  sglLoadIdentity();
  sglRotatef(mLong, 0,1,0);
  unsigned int maxuint=(unsigned int)-1; double wZ=((double)z)/((double)maxuint);
  GLdouble modelview[16]; sglGetDoublev (GL_MODELVIEW_MATRIX, modelview) ;
  GLdouble projection[16]; sglGetDoublev (GL_PROJECTION_MATRIX, projection) ;
  GLint viewport[4]; sglGetIntegerv (GL_VIEWPORT, viewport);
  GLdouble oX,oY,oZ;
  sgluUnProject (X, viewport[3]-Y, wZ, modelview, projection, viewport, &oX, &oY, &oZ);
  sglMatrixMode(GL_PROJECTION);
  sglPopMatrix();
  //
  IsDragging=TRUE;
  dX=oX; dY=oY; dZ=oZ;
  dR=sqrt(dX*dX+dZ*dZ);
  dA=deg(atan2(dZ,dX)); // note that mLong has already been included into dA sort of
  char c[100]; sprintf(c,"%0.1f  %0.1f  %0.1f   =   %0.1f  %0.1f",dX,dY,dZ,dR,dA);
  Edit1->Text=c;
}
//---------------------------------------------------------------------------



void __fastcall TForm1::ScrGL1MouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{ if (!IsDragging) {ScrGL1->Repaint();return;}
  PrepareProjection(NULL);
  sglMatrixMode(GL_PROJECTION);
  sglPushMatrix();
  double r=30.0, rLong=rad(cLong), rLat=rad(cLat);
  sgluLookAt(r*cos(rLong)*cos(rLat),r*sin(rLat),r*sin(rLong)*cos(rLat),  0,0,0,  0,1,0);
  sglMatrixMode(GL_MODELVIEW);
  sglLoadIdentity();
  GLdouble modelview[16]; sglGetDoublev (GL_MODELVIEW_MATRIX, modelview) ;
  GLdouble projection[16]; sglGetDoublev (GL_PROJECTION_MATRIX, projection) ;
  GLint viewport[4]; sglGetIntegerv (GL_VIEWPORT, viewport);
  // pick ray normal corresponding to mouse. Starts at ra in the screen, ends at rb in the distance
  int wX=X, wY=viewport[3]-Y;
  double raX,raY,raZ,rbX,rbY,rbZ;
  sgluUnProject (wX, wY, 0.0,  modelview, projection, viewport, &raX, &raY, &raZ);
  sgluUnProject (wX, wY, 1.0,  modelview, projection, viewport, &rbX, &rbY, &rbZ);
  sglMatrixMode(GL_PROJECTION);
  sglPopMatrix();
  rbX-=raX; rbY-=raY; rbZ-=raZ;
  double t=sqrt(rbX*rbX+rbY*rbY+rbZ*rbZ); rbX/=t; rbY/=t; rbZ/=t;
  // Now figure out where this ray vector hits the drag-plane dY. This is where the cursor really is
  double f=(dY-raY)/rbY;
  double cX=raX+f*rbX, cZ=raZ+f*rbZ;
  double cA=deg(atan2(cZ,cX));
  double cR=sqrt(cX*cX+cZ*cZ);
  char c[100]; sprintf(c,"%0.1f  %0.1f  %0.1f   =   %0.1f  %0.1f",cX,dY,cZ,cR,cA);
  Edit1->Text=c;
  mLong=dA-cA;//dA-cA;//dLong-cA+dA;
  ScrGL1->Repaint();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ScrGL1MouseUp(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{ IsDragging=FALSE;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Timer1Timer(TObject *Sender)
{ if (IsDragging) return;
  if (GetForegroundWindow()!=Handle) return;
  POINT pt; GetCursorPos(&pt);
  pt=ScrGL1->ScreenToClient(pt);
  int X=pt.x, Y=pt.y;
  if (X<0 || Y<0 || X>ScrGL1->Width || Y>ScrGL1->Height) return;
  BOOL c=FALSE;
  if (X>=0.95*ScrGL1->Width) {cLong-=1;c=TRUE;}
  if (X<=0.05*ScrGL1->Width) {cLong+=1;c=TRUE;}
  if (Y<=0.05*ScrGL1->Height) {cLat+=1;c=TRUE;}
  if (Y>=0.95*ScrGL1->Height) {cLat-=1;c=TRUE;}
  if (cLat>85) cLat=85;
  if (cLat<-85) cLat=-85;
  if (!c) return;
  ScrGL1->Repaint();
}
//---------------------------------------------------------------------------




void __fastcall TForm1::ListBox1Click(TObject *Sender)
{ if (ListBox1->ItemIndex==-1) return;
  AnsiString fn=GLICDList1->Details[ListBox1->ItemIndex]->FileName;
  Edit1->Text=fn;
  ScrGL1->GLICD=fn;
  ScrGL1->Repaint();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ScrGL1GLError(TObject *Sender, AnsiString err)
{ Edit1->Text=err;
}
//---------------------------------------------------------------------------

