//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Unit4.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "ScrGL"
#pragma resource "*.dfm"
TForm4 *Form4;
//---------------------------------------------------------------------------

double __fastcall rad(double d) {return d*2.0*3.141592/360.0;}
double __fastcall deg(double d) {return d*180.0/3.141592;}
#define PI 3.141592

#define YAW_RATE        5.0f
#define PITCH_RATE      5.0f
#define ROLL_RATE       5.0f

float cameraYaw    = 0.0f;
float cameraPitch  = 0.0f;
float cameraRoll   = 0.0f;
float cameraX      = 0.0f;
float cameraY      = 0.0f;
float cameraZ      = 8.0f;
float fovX         = 90.0f;

float rgbCubeYaw   = 0.0f;
float rgbCubePitch = 0.0f;
float rgbCubeRoll  = 0.0f;
float rgbCubeX     =-2.0f;
float rgbCubeY     = 0.0f;
float rgbCubeZ     = 0.0f;
float rgbCubeScale = 1.0f;


__fastcall TForm4::TForm4(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm4::ScrGL1GLInit(TObject *Sender)
{
  sglClearColor(0.0f, 0.0f, 0.0f, 0.0f);
  sglClearDepth(1.0);
  sglDepthFunc(GL_LEQUAL);  // Superimpose smaller Z values over larger ones
  sglShadeModel(GL_SMOOTH); // Smooth shading
  sglFrontFace(GL_CCW);
  sglPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  sglBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
  sglAlphaFunc(GL_GEQUAL, 0.07f);
  sglDisable(GL_ALPHA_TEST);
  sglDisable(GL_BLEND);
  sglDisable(GL_CULL_FACE);
  sglEnable(GL_DEPTH_TEST); // Z buffering is go...
  PrepareProjection(NULL);
  sglMatrixMode(GL_MODELVIEW);
}
void __fastcall TForm4::PrepareProjection(POINT *pt)
{ int width=ClientWidth, height=ClientHeight;
  double  znear = 0.7;   // Put the screen 1 unit in front of the "eye"
  double  zfar  = 250.0; // Note that the ratio far/near is to be minimized
  // Calculate the screen (ie a neutral) aspect ratio ie squares are squares
  double  aspect = (GLdouble)width/(GLdouble)height;
  // Set a viewport to the entire screen, its all one big 3D window now
  sglViewport(0, 0, width, height);
  // Set the Projection matrix
  sglMatrixMode(GL_PROJECTION);
  sglLoadIdentity();
  sgluPerspective(fovX/aspect, aspect, znear, zfar);
  sgluLookAt(0,0,0,  0,0,-10,  0,1,0);
  sglMatrixMode(GL_MODELVIEW);
}
//---------------------------------------------------------------------------



// Simple cube with blended colored faces
void DrawRGBCube()
{ sglMatrixMode(GL_MODELVIEW);
  sglLoadIdentity(); // Set Model-View to the identity matrix
  sglTranslatef(rgbCubeX, rgbCubeY, rgbCubeZ);
  sglScalef(rgbCubeScale, rgbCubeScale, rgbCubeScale);
  sglRotatef(rgbCubePitch, 1.0f, 0.0f, 0.0f); // rotate about the x unit vector
  sglRotatef(rgbCubeYaw,   0.0f, 1.0f, 0.0f); // rotate about the y unit vector
  sglRotatef(rgbCubeRoll,  0.0f, 0.0f, 1.0f); // rotate about the z unit vector
  sglBegin(GL_QUADS);
    sglColor3f(0.0f, 0.0f, 0.0f); // black corner
    sglVertex3f(-1.0f, -1.0f, -1.0f);
    sglColor3f(0.0f, 1.0f, 0.0f); // green
    sglVertex3f(-1.0f,  1.0f, -1.0f);
    sglColor3f(1.0f, 1.0f, 0.0f); // yellow
    sglVertex3f( 1.0f,  1.0f, -1.0f);
    sglColor3f(1.0f, 0.0f, 0.0f); // red
    sglVertex3f( 1.0f, -1.0f, -1.0f);
    //
    sglColor3f(1.0f, 0.0f, 1.0f);  // purple corner
    sglVertex3f( 1.0f, -1.0f,  1.0f);
    sglColor3f(1.0f, 1.0f, 1.0f);  // white
    sglVertex3f( 1.0f,  1.0f,  1.0f);
    sglColor3f(0.0f, 1.0f, 1.0f);  // cyan
    sglVertex3f(-1.0f,  1.0f,  1.0f);
    sglColor3f(0.0f, 0.0f, 1.0f);  // blue
    sglVertex3f(-1.0f, -1.0f,  1.0f);
    //
    sglColor3f(0.0f, 1.0f, 0.0f);  // green corner
    sglVertex3f(-1.0f,  1.0f, -1.0f);
    sglColor3f(0.0f, 1.0f, 1.0f); // cyan
    sglVertex3f(-1.0f,  1.0f,  1.0f);
    sglColor3f(1.0f, 1.0f, 1.0f);  // white
    sglVertex3f( 1.0f,  1.0f,  1.0f);
    sglColor3f(1.0f, 1.0f, 0.0f); // yellow
    sglVertex3f( 1.0f,  1.0f, -1.0f);
    //
    sglColor3f(1.0f, 0.0f, 0.0f); // red corner
    sglVertex3f( 1.0f, -1.0f, -1.0f);
    sglColor3f(1.0f, 0.0f, 1.0f); // purple
    sglVertex3f( 1.0f, -1.0f,  1.0f);
    sglColor3f(0.0f, 0.0f, 1.0f); // blue
    sglVertex3f(-1.0f, -1.0f,  1.0f);
    sglColor3f(0.0f, 0.0f, 0.0f); // black
    sglVertex3f(-1.0f, -1.0f, -1.0f);
    //
    sglColor3f(0.0f, 0.0f, 1.0f); // blue
    sglVertex3f(-1.0f, -1.0f,  1.0f);
    sglColor3f(0.0f, 1.0f, 1.0f); // cyan
    sglVertex3f(-1.0f,  1.0f,  1.0f);
    sglColor3f(0.0f, 1.0f, 0.0f); // green
    sglVertex3f(-1.0f,  1.0f, -1.0f);
    sglColor3f(0.0f, 0.0f, 0.0f); // black corner
    sglVertex3f(-1.0f, -1.0f, -1.0f);
    //
    sglColor3f(1.0f, 0.0f, 0.0f); // red
    sglVertex3f( 1.0f, -1.0f, -1.0f);
    sglColor3f(1.0f, 1.0f, 0.0f);  // yellow
    sglVertex3f( 1.0f,  1.0f, -1.0f);
    sglColor3f(1.0f, 1.0f, 1.0f);  // white
    sglVertex3f( 1.0f,  1.0f,  1.0f);
    sglColor3f(1.0f, 0.0f, 1.0f);  // purple corner
    sglVertex3f( 1.0f, -1.0f,  1.0f);
  sglEnd();
}

void Draw()
{ // Setup for the scene, Basically just clear the buffers
  // Wipe the color and Depth Buffers
  sglClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  // Manipulate the PROJECTION matrix for all models
  // basically use the projection matrix to simulate observer position
  // otherwise we'd need an extra matrix transform for every point
  // this way there's just two.
  sglMatrixMode(GL_PROJECTION);
  sglPushMatrix();
    sglRotatef(-cameraPitch, 1.0f, 0.0f, 0.0f); // rotate about the y unit vector
    sglRotatef(-cameraYaw,   0.0f, 1.0f, 0.0f); // rotate about the y unit vector
    sglRotatef(-cameraRoll,  0.0f, 0.0f, 1.0f); // rotate about the y unit vector
    sglTranslatef(-cameraX, -cameraY, -cameraZ);
  // Manipulate the MODELVIEW matrix for each model
  // the modelview matrix. Remember that you manipulate the view
  // matrix and not the objects themselves so all so all transforms
  // are logically backwards from whats intuitive
  //
  sglMatrixMode(GL_MODELVIEW);
  sglPushMatrix();
    DrawRGBCube();
  sglMatrixMode(GL_PROJECTION);
  sglPopMatrix();
  sglMatrixMode(GL_MODELVIEW);
  sglPopMatrix(); // restore the original model-view matrix
}



//---------------------------------------------------------------------------
void __fastcall TForm4::Timer1Timer(TObject *Sender)
{ rgbCubeYaw   -= YAW_RATE;
  rgbCubePitch -= PITCH_RATE;
  rgbCubeRoll  -= ROLL_RATE;
  ScrGL1->Repaint();
}

void __fastcall TForm4::ScrGL1Resize(TObject *Sender)
{ PrepareProjection(NULL);
}

void __fastcall TForm4::ScrGL1GLPaint(TObject *Sender)
{ Draw();
  sglFinish(); // Block the program until cached rendering commands are complete
}
//---------------------------------------------------------------------------

void __fastcall TForm4::ScrGL1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{ Close();
}
//---------------------------------------------------------------------------

