//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include <math.h>
#include <gl\gl.h>
#include "ScrGL.h"
#include "Unit2.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm2 *Form2;
//---------------------------------------------------------------------------
double __fastcall rad(double d) {return d*2.0*3.141592/360.0;}
double __fastcall deg(double d) {return d*180.0/3.141592;}
#define PI 3.141592

#define YAW_RATE        5.0f
#define PITCH_RATE      5.0f
#define ROLL_RATE       5.0f

float cameraYaw    = 0.0f;
float cameraPitch  = 0.0f;
float cameraRoll   = 0.0f;
float cameraX      = 0.0f;
float cameraY      = 0.0f;
float cameraZ      = 8.0f;
float fovX         = 90.0f;

float rgbCubeYaw   = 0.0f;
float rgbCubePitch = 0.0f;
float rgbCubeRoll  = 0.0f;
float rgbCubeX     =-2.0f;
float rgbCubeY     = 0.0f;
float rgbCubeZ     = 0.0f;
float rgbCubeScale = 1.0f;

float texCubeYaw   = 0.0f;
float texCubePitch = 0.0f;
float texCubeRoll  = 0.0f;
float texCubeX     = 2.0f;
float texCubeY     = 0.0f;
float texCubeZ     = 0.0f;
float texCubeScale = 1.0f;

LONG texID = 1; /* next texture would be given ID 2, then 3 etc */
LONG texWidth = 4;
LONG texHeight = 4;
BYTE texImage[] = { /* rgba 8 bits per pixel */
  64, 255, 0,   255, /* 0,0 */
  64, 255, 0,   255, /* 1,0 */
  64, 64,  255, 255, /* 2,0 */
  64, 255, 0,   255, /* 3,0 */
  64, 255, 0,   255, /* 0,1 */
  64, 64,  255, 255, /* 1,1 */
  64, 255, 0,   255, /* 2,1 */
  64, 255, 0,   255, /* 3,1 */
  64, 64,  255, 255, /* 0,2 */
  64, 255, 0,   255, /* 1,2 */
  64, 64,  255, 255, /* 2,2 */
  64, 64,  255, 255, /* 3,2 */
  64, 255, 0,   255, /* 0,3 */
  64, 64,  255, 255, /* 1,3 */
  64, 255, 0,   255, /* 2,3 */
  64, 255, 0,   255  /* 3,3 */
};



__fastcall TForm2::TForm2(TComponent* Owner)
    : TForm(Owner)
{ hLib=sglLoadLibrary("opengl32.dll");
  dLat=30; dLong=20;
}
void __fastcall TForm2::CreateParams(TCreateParams &p)
{ TForm::CreateParams(p);
  p.WindowClass.style |= CS_OWNDC;
}
void __fastcall TForm2::WndProc(TMessage &msg)
{ if (msg.Msg==WM_ERASEBKGND) return;
  TForm::WndProc(msg);
}

__fastcall TForm2::~TForm2()
{ if (hLib!=NULL) sglFreeLibrary(hLib); hLib=NULL;
}
//---------------------------------------------------------------------------
void __fastcall TForm2::SetupPixelFormat()
{ PIXELFORMATDESCRIPTOR pfd; ZeroMemory(&pfd,sizeof(pfd));
  pfd.nSize = sizeof(pfd);
  pfd.nVersion = 1;
  pfd.dwFlags = PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL | PFD_DOUBLEBUFFER;
  pfd.iPixelType = PFD_TYPE_RGBA;
  pfd.cColorBits = 16;
  pfd.cDepthBits = 16;
  pfd.dwLayerMask = PFD_MAIN_PLANE;
  pfd.cAccumBits = 0;
  pfd.cStencilBits = 0;
  int pixelformat = sglChoosePixelFormat(hdc,&pfd);
  if (pixelformat==0)  {MessageBox(NULL, "ChoosePixelFormat failed", "Error", MB_OK); PostQuitMessage(0); return;}
  sglDescribePixelFormat(hdc,pixelformat,sizeof(pfd),&pfd);
  if (sglSetPixelFormat(hdc, pixelformat, &pfd) == FALSE) {MessageBox(NULL, "SetPixelFormat failed", "Error", MB_OK); PostQuitMessage(0); return;}
}
//---------------------------------------------------------------------------
void __fastcall TForm2::FormCreate(TObject *Sender)
{ hdc=Canvas->Handle;
  SetupPixelFormat();
  hGl=sglCreateContext(hdc);
  sglMakeCurrent(hdc,hGl);
  //
  sglClearColor(0.0f, 0.0f, 0.0f, 0.0f);
  sglClearDepth(1.0);
  sglDepthFunc(GL_LEQUAL);  // Superimpose smaller Z values over larger ones
  sglShadeModel(GL_SMOOTH); // Smooth shading
  sglFrontFace(GL_CCW);
  sglPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  sglBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
  sglAlphaFunc(GL_GEQUAL, 0.07f);
  sglDisable(GL_ALPHA_TEST);
  sglDisable(GL_BLEND);
  sglDisable(GL_CULL_FACE);
  sglEnable(GL_DEPTH_TEST); // Z buffering is go...
  PrepareProjection();
  sglMatrixMode(GL_MODELVIEW);
  //
  sglBindTexture(GL_TEXTURE_2D, texID);
  sglTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S,     (float)GL_REPEAT);
  sglTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T,     (float)GL_REPEAT);
  sglTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, (float)GL_LINEAR); // GL_LINEAR would be bilinear filtering
  sglTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, (float)GL_LINEAR); // GL_LINEAR would be bilinear filtering
  sglTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE,        (float)GL_DECAL);
  sglTexImage2D(GL_TEXTURE_2D, 0, 4, texWidth, texHeight, 0, GL_RGBA, GL_UNSIGNED_BYTE, texImage );
}
void __fastcall TForm2::PrepareProjection()
{ int width=ClientWidth, height=ClientHeight;
  double  znear = 0.7;   // Put the screen 1 unit in front of the "eye"
  double  zfar  = 250.0; // Note that the ratio far/near is to be minimized
  // Calculate the screen (ie a neutral) aspect ratio ie squares are squares
  double  aspect = (GLdouble)width/(GLdouble)height;
  // Set a viewport to the entire screen, its all one big 3D window now
  sglViewport(0, 0, width, height);
  // Set the Projection matrix
  sglMatrixMode(GL_PROJECTION);
  sglLoadIdentity();
  sgluPerspective(fovX/aspect, aspect, znear, zfar);
  sgluLookAt(0,0,0,  0,0,-10,  0,1,0);
  sglMatrixMode(GL_MODELVIEW);
}
//---------------------------------------------------------------------------
void __fastcall TForm2::FormDestroy(TObject *Sender)
{ if (hGl!=NULL) sglDeleteContext(hGl); hGl=NULL;
}
//---------------------------------------------------------------------------
// Note that order is correct for face-culling
void DrawTextureCube(GLint texNum)
{ sglMatrixMode(GL_MODELVIEW);
  sglLoadIdentity(); // Set Model-View to the identity matrix
  sglTranslatef(texCubeX, texCubeY, texCubeZ);
  sglScalef(texCubeScale, texCubeScale, texCubeScale);
  sglRotatef(texCubePitch, 1.0f, 0.0f, 0.0f); // rotate about the x unit vector
  sglRotatef(texCubeYaw,   0.0f, 1.0f, 0.0f); // rotate about the y unit vector
  sglRotatef(texCubeRoll,  0.0f, 0.0f, 1.0f); // rotate about the z unit vector
  sglEnable(GL_TEXTURE_2D); // Turn on textures */
  sglBindTexture(GL_TEXTURE_2D, texNum);  // Draw a textured side of the cube
  sglBegin(GL_QUADS);
    sglTexCoord2f(0.0f, 0.0f); sglVertex3f(-1.0f, -1.0f, -1.0f);
    sglTexCoord2f(0.0f, 1.0f); sglVertex3f(-1.0f,  1.0f, -1.0f);
    sglTexCoord2f(1.0f, 1.0f); sglVertex3f( 1.0f,  1.0f, -1.0f);
    sglTexCoord2f(1.0f, 0.0f); sglVertex3f( 1.0f, -1.0f, -1.0f);
    //
    sglTexCoord2f(0.0f, 0.0f); sglVertex3f( 1.0f, -1.0f,  1.0f);
    sglTexCoord2f(0.0f, 1.0f); sglVertex3f( 1.0f,  1.0f,  1.0f);
    sglTexCoord2f(1.0f, 1.0f); sglVertex3f(-1.0f,  1.0f,  1.0f);
    sglTexCoord2f(1.0f, 0.0f); sglVertex3f(-1.0f, -1.0f,  1.0f);
    //
    sglTexCoord2f(0.0f, 0.0f); sglVertex3f(-1.0f,  1.0f, -1.0f);
    sglTexCoord2f(0.0f, 1.0f); sglVertex3f(-1.0f,  1.0f,  1.0f);
    sglTexCoord2f(1.0f, 1.0f); sglVertex3f( 1.0f,  1.0f,  1.0f);
    sglTexCoord2f(1.0f, 0.0f); sglVertex3f( 1.0f,  1.0f, -1.0f);
    //
    sglTexCoord2f(0.0f, 0.0f); sglVertex3f( 1.0f, -1.0f, -1.0f);
    sglTexCoord2f(0.0f, 1.0f); sglVertex3f( 1.0f, -1.0f,  1.0f);
    sglTexCoord2f(1.0f, 1.0f); sglVertex3f(-1.0f, -1.0f,  1.0f);
    sglTexCoord2f(1.0f, 0.0f); sglVertex3f(-1.0f, -1.0f, -1.0f);
    //
    sglTexCoord2f(0.0f, 0.0f); sglVertex3f(-1.0f, -1.0f, -1.0f);
    sglTexCoord2f(0.0f, 1.0f); sglVertex3f(-1.0f,  1.0f, -1.0f);
    sglTexCoord2f(1.0f, 1.0f); sglVertex3f(-1.0f,  1.0f,  1.0f);
    sglTexCoord2f(1.0f, 0.0f); sglVertex3f(-1.0f, -1.0f,  1.0f);
    //
    sglTexCoord2f(0.0f, 0.0f); sglVertex3f( 1.0f, -1.0f,  1.0f);
    sglTexCoord2f(0.0f, 1.0f); sglVertex3f( 1.0f,  1.0f,  1.0f);
    sglTexCoord2f(1.0f, 1.0f); sglVertex3f( 1.0f,  1.0f, -1.0f);
    sglTexCoord2f(1.0f, 0.0f); sglVertex3f( 1.0f, -1.0f, -1.0f);
  sglEnd();
  sglDisable(GL_TEXTURE_2D);
}

// Simple cube with blended colored faces
void DrawRGBCube()
{ sglMatrixMode(GL_MODELVIEW);
  sglLoadIdentity(); // Set Model-View to the identity matrix
  sglTranslatef(rgbCubeX, rgbCubeY, rgbCubeZ);
  sglScalef(rgbCubeScale, rgbCubeScale, rgbCubeScale);
  sglRotatef(rgbCubePitch, 1.0f, 0.0f, 0.0f); // rotate about the x unit vector
  sglRotatef(rgbCubeYaw,   0.0f, 1.0f, 0.0f); // rotate about the y unit vector
  sglRotatef(rgbCubeRoll,  0.0f, 0.0f, 1.0f); // rotate about the z unit vector
  sglBegin(GL_QUADS);
    sglColor3f(0.0f, 0.0f, 0.0f); // black corner 
    sglVertex3f(-1.0f, -1.0f, -1.0f);
    sglColor3f(0.0f, 1.0f, 0.0f); // green 
    sglVertex3f(-1.0f,  1.0f, -1.0f);
    sglColor3f(1.0f, 1.0f, 0.0f); // yellow 
    sglVertex3f( 1.0f,  1.0f, -1.0f);
    sglColor3f(1.0f, 0.0f, 0.0f); // red 
    sglVertex3f( 1.0f, -1.0f, -1.0f);
    //
    sglColor3f(1.0f, 0.0f, 1.0f);  // purple corner 
    sglVertex3f( 1.0f, -1.0f,  1.0f);
    sglColor3f(1.0f, 1.0f, 1.0f);  // white 
    sglVertex3f( 1.0f,  1.0f,  1.0f);
    sglColor3f(0.0f, 1.0f, 1.0f);  // cyan
    sglVertex3f(-1.0f,  1.0f,  1.0f);
    sglColor3f(0.0f, 0.0f, 1.0f);  // blue 
    sglVertex3f(-1.0f, -1.0f,  1.0f);
    //
    sglColor3f(0.0f, 1.0f, 0.0f);  // green corner 
    sglVertex3f(-1.0f,  1.0f, -1.0f);
    sglColor3f(0.0f, 1.0f, 1.0f); // cyan 
    sglVertex3f(-1.0f,  1.0f,  1.0f);
    sglColor3f(1.0f, 1.0f, 1.0f);  // white 
    sglVertex3f( 1.0f,  1.0f,  1.0f);
    sglColor3f(1.0f, 1.0f, 0.0f); // yellow 
    sglVertex3f( 1.0f,  1.0f, -1.0f);
    //
    sglColor3f(1.0f, 0.0f, 0.0f); // red corner 
    sglVertex3f( 1.0f, -1.0f, -1.0f);
    sglColor3f(1.0f, 0.0f, 1.0f); // purple 
    sglVertex3f( 1.0f, -1.0f,  1.0f);
    sglColor3f(0.0f, 0.0f, 1.0f); // blue 
    sglVertex3f(-1.0f, -1.0f,  1.0f);
    sglColor3f(0.0f, 0.0f, 0.0f); // black 
    sglVertex3f(-1.0f, -1.0f, -1.0f);
    //
    sglColor3f(0.0f, 0.0f, 1.0f); // blue 
    sglVertex3f(-1.0f, -1.0f,  1.0f);
    sglColor3f(0.0f, 1.0f, 1.0f); // cyan
    sglVertex3f(-1.0f,  1.0f,  1.0f);
    sglColor3f(0.0f, 1.0f, 0.0f); // green 
    sglVertex3f(-1.0f,  1.0f, -1.0f);
    sglColor3f(0.0f, 0.0f, 0.0f); // black corner 
    sglVertex3f(-1.0f, -1.0f, -1.0f);
    //
    sglColor3f(1.0f, 0.0f, 0.0f); // red 
    sglVertex3f( 1.0f, -1.0f, -1.0f);
    sglColor3f(1.0f, 1.0f, 0.0f);  // yellow 
    sglVertex3f( 1.0f,  1.0f, -1.0f);
    sglColor3f(1.0f, 1.0f, 1.0f);  // white 
    sglVertex3f( 1.0f,  1.0f,  1.0f);
    sglColor3f(1.0f, 0.0f, 1.0f);  // purple corner
    sglVertex3f( 1.0f, -1.0f,  1.0f);
  sglEnd();
}

void Draw()
{ // Setup for the scene, Basically just clear the buffers
  // Wipe the color and Depth Buffers
  sglClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  // Manipulate the PROJECTION matrix for all models
  // basically use the projection matrix to simulate observer position
  // otherwise we'd need an extra matrix transform for every point
  // this way there's just two.
  sglMatrixMode(GL_PROJECTION);
  sglPushMatrix();
    sglRotatef(-cameraPitch, 1.0f, 0.0f, 0.0f); // rotate about the y unit vector
    sglRotatef(-cameraYaw,   0.0f, 1.0f, 0.0f); // rotate about the y unit vector
    sglRotatef(-cameraRoll,  0.0f, 0.0f, 1.0f); // rotate about the y unit vector
    sglTranslatef(-cameraX, -cameraY, -cameraZ);
  // Manipulate the MODELVIEW matrix for each model
  // the modelview matrix. Remember that you manipulate the view
  // matrix and not the objects themselves so all so all transforms
  // are logically backwards from whats intuitive
  //
  sglMatrixMode(GL_MODELVIEW);
  sglPushMatrix();
    // Draw all my objects
    DrawRGBCube();
    DrawTextureCube(texID);

  // restore the original projection matrix
  sglMatrixMode(GL_PROJECTION);
  sglPopMatrix();
  sglMatrixMode(GL_MODELVIEW);
  sglPopMatrix(); // restore the original model-view matrix
}



void __fastcall TForm2::FormPaint(TObject *Sender)
{ if (hGl==NULL) return;
  Draw();
  sglFinish(); // Block the program until cached rendering commands are complete
  sglSwapBuffers(hdc); // Swap Buffers once rendering is complete
}
//---------------------------------------------------------------------------
void __fastcall TForm2::Timer1Timer(TObject *Sender)
{ texCubeYaw   += YAW_RATE;
  texCubePitch += PITCH_RATE;
  texCubeRoll  += ROLL_RATE;
  rgbCubeYaw   -= YAW_RATE;
  rgbCubePitch -= PITCH_RATE;
  rgbCubeRoll  -= ROLL_RATE;
  Repaint();
}
//---------------------------------------------------------------------------
void __fastcall TForm2::FormResize(TObject *Sender)
{ PrepareProjection();
}
//---------------------------------------------------------------------------
void __fastcall TForm2::FormMouseDown(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{ Close();
}
//---------------------------------------------------------------------------

