#include <vcl.h>
#pragma hdrstop
USERES("ScrGL.res");
USERES("ScrGL.dcr");
USEPACKAGE("vcl35.bpi");
USEPACKAGE("vclx35.bpi");
//---------------------------------------------------------------------------
#include <gl\gl.h>
#include <math.h>
#include "ScrGL.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------

AnsiString __fastcall ExtractDirFromFilePath(AnsiString s)
{ AnsiString t=ExtractFilePath(s);
  if (t[t.Length()-1]=='\\') t=t.SubString(1,t.Length()-1);
  return t;
}

// GLDriver - Just a single string. Setting it will deduce whether it uses full style
// GLFullMode - One of 512x384, 640x480, 800x600, 1024x768
// If the driver turned out to be a 3dfx driver, then we will ignore
// the current width, height, align and go into full-screen mode.
// Otherwise we will respect the current dimensions.

bool __fastcall GetICDDetails(AnsiString afn,TGLICDDetails *d)
{ char *fn=afn.c_str();
  // It would be nice to load each of them just to check that they were actually
  // opengl dlls. But this gives an error in some cases.
  // It's not wise to load a hardware driver if you don't actually have that
  // hardware on your machine, and don't intend to use it!
  //HINSTANCE hLib=LoadLibrary(fn);
  //if (hLib==NULL) return false;
  //void *p=GetProcAddress(hLib,"glBegin");
  //FreeLibrary(hLib);
  //if (p==NULL) return false;
  d->FileName=afn;
  d->CompanyName="";
  d->FileDescription="";
  d->FileVersion="";
  d->Uses3dfxStyle=false;
  DWORD dummy; DWORD vis=GetFileVersionInfoSize(fn,&dummy);
  if (vis==0) return true;
  void *vData;
  vData=(void *)new char[(UINT)vis];
  if (!GetFileVersionInfo(fn,dummy,vis,vData)) {delete vData;return true;}
  char vn[100];
  strcpy(vn,"\\VarFileInfo\\Translation");
  LPVOID transblock; UINT vsize;
  BOOL res=VerQueryValue(vData,vn,&transblock,&vsize);
  if (!res) {delete vData;return true;}
  // Swap the words so wsprintf will print the lang-charset in the correct format.
  *(DWORD *)transblock = MAKELONG(HIWORD(*(DWORD *)transblock), LOWORD(*(DWORD *)transblock));
  char *info;
  info="CompanyName"; wsprintf(vn,"\\StringFileInfo\\%08lx\\%s",*(DWORD *)transblock,info);
  char *CompanyName=NULL; VerQueryValue(vData,vn,(LPVOID*)&CompanyName,&vsize);
  info="FileDescription"; wsprintf(vn,"\\StringFileInfo\\%08lx\\%s",*(DWORD *)transblock,info);
  char *FileDescription=NULL; VerQueryValue(vData,vn,(LPVOID*)&FileDescription,&vsize);
  info="FileVersion"; wsprintf(vn,"\\StringFileInfo\\%08lx\\%s",*(DWORD *)transblock,info);
  char *FileVersion=NULL; VerQueryValue(vData,vn,(LPVOID*)&FileVersion,&vsize);
  d->CompanyName=CompanyName;
  d->FileDescription=FileDescription;
  d->FileVersion=FileVersion;
  delete vData;
  AnsiString de=d->FileDescription, ce=d->CompanyName;
  int i1=de.Pos(ce);
  if (i1!=0)
  { int i2=i1+ce.Length();
    de=de.SubString(1,i1-1)+de.SubString(i2+1,de.Length()-i2-1);
    d->FileDescription=de;
  }
  AnsiString b=d->CompanyName+" "+d->FileDescription+" "+d->FileVersion;
  b=b.LowerCase();
  int pos=b.Pos("3dfx"); d->Uses3dfxStyle=(pos!=0);
  return true;
}



__fastcall TGLICDList::TGLICDList(TComponent *Owner) : TComponent(Owner)
{ FList=NULL;
  FSearchPath=NULL;
}
__fastcall TGLICDList::~TGLICDList()
{ DeleteList();
  if (FSearchPath!=NULL) delete FSearchPath; FSearchPath=NULL;
}
TStrings* __fastcall TGLICDList::GetSearchPath()
{ if (FSearchPath!=NULL) return FSearchPath;
  DeleteList();
  FSearchPath=new TStringList();
  FSearchPath->Add(ExtractDirFromFilePath(ExtractFilePath(Application->ExeName))+"\\*.dll");
  char c[MAX_PATH]; GetWindowsDirectory(c,MAX_PATH); AnsiString s=c; s=s+"\\open*.dll"; FSearchPath->Add(s);
  GetSystemDirectory(c,MAX_PATH); s=c; s=s+"\\open*.dll"; FSearchPath->Add(s);
  return FSearchPath;
}
void __fastcall TGLICDList::SetSearchPath(TStrings *s)
{ if (FSearchPath!=NULL) delete FSearchPath;
  FSearchPath=new TStringList();
  FSearchPath->Assign(s);
  DeleteList();
}
TGLICDDetails* __fastcall TGLICDList::GetDetail(int i)
{ BuildList();
  void *r=FList->Objects[i];
  return (TGLICDDetails*)r;
}
int __fastcall TGLICDList::FilenameToIndex(AnsiString fn)
{ fn=fn.UpperCase();
  AnsiString efn=ExtractFileName(fn);
  for (int i=0; i<Count; i++)
  { TGLICDDetails *d=Details[i];
    AnsiString icdfn=d->FileName.UpperCase();
    AnsiString eicdfn=ExtractFileName(d->FileName);
    if (fn==icdfn || efn==eicdfn) return i;
  }
  return 0;
}
int __fastcall TGLICDList::GetCount()
{ BuildList();
  return FList->Count;
}
void __fastcall TGLICDList::DeleteList()
{ if (FList==NULL) return;
  for (int i=0; i<FList->Count; i++)
  { TGLICDDetails *icd=(TGLICDDetails*)FList->Objects[i];
    if (icd!=NULL) delete icd; FList->Objects[i]=NULL;
  }
  delete FList;
  FList=NULL;
}
void __fastcall TGLICDList::BuildList()
{ TStrings *sp=SearchPath; // we must do this first, because getting SearchPath might delete the list
  if (FList!=NULL) return;
  FList=new TStringList();
  for (int i=0; i<sp->Count; i++)
  { AnsiString search=sp->Strings[i];
    AnsiString dir=ExtractDirFromFilePath(ExtractFilePath(search));
    WIN32_FIND_DATA fd;
    HANDLE hFind=FindFirstFile(search.c_str(),&fd);
    bool res=(hFind!=INVALID_HANDLE_VALUE);
    while (res)
    { TGLICDDetails *d=new TGLICDDetails();
      bool lres=GetICDDetails(dir+fd.cFileName,d);
      if (!lres) delete d;
      else
      { AnsiString b=ExtractFileName(d->FileName)+" - "+d->CompanyName+" "+d->FileDescription+" "+d->FileVersion;
        FList->AddObject(b,d);
      }
      res=FindNextFile(hFind,&fd);
    }
    if (hFind!=INVALID_HANDLE_VALUE) FindClose(hFind);
  }
}
TStrings* __fastcall TGLICDList::GetList()
{ BuildList();
  return FList;
}



__fastcall TScrGL::TScrGL(TComponent *Owner) : TWinControl(Owner)
{ ControlStyle << csOpaque;
  FColor=clNone; TWinControl::Color=FColor;
  Width=100; Height=100;
  //
  FIsMouseClipped=false;
  Fhgl=NULL; Fhdc=NULL;
  FGLColorBits=32; FGLDepthBits=32;
  FGLFlags.Clear(); FGLFlags << f_DOUBLEBUFFER << f_DRAW_TO_WINDOW << f_SUPPORT_OPENGL;
  FGLPixelType=pt_TYPE_RGBA;
  FOnGLPaint=NULL; FOnGLInit=NULL; FOnGLDestroy=NULL; FOnResize=NULL;
  FGLICD="opengl32.dll"; FhGLib=NULL;  GiveUpTrying=false;
  hwndSubclass=NULL;
  FScreenSize=ss512x384;
  FIsSuppressed=false;
}
void __fastcall TScrGL::CreateParams(TCreateParams &p)
{ TWinControl::CreateParams(p);
  p.WindowClass.style |= CS_OWNDC; strcat(p.WinClassName,"Owndc");
}
__fastcall TScrGL::~TScrGL()
{ UnclipMouse();
  InvalidateGLHandle();
  sglFreeLibrary(FhGLib); FhGLib=NULL;
  if (Fhdc!=NULL) ReleaseDC(Handle,Fhdc); Fhdc=NULL;
}

void __fastcall TScrGL::SetGLICD(AnsiString s)
{ if (FGLICD==s) return;
  InvalidateGLHandle();
  sglFreeLibrary(FhGLib); FhGLib=NULL;
  FGLICD=s;
}

void __fastcall TScrGL::SetScreenSize(TGLScreenSize s)
{ if (FScreenSize==s) return;
  InvalidateGLHandle();
  FScreenSize=s;
}


// If you're using a 3dfx style card, then immediately upon creating the glContext
// we do some magic:
// we clip the mouse, and scale it, so that the mouse can never leave its region
LRESULT CALLBACK ScrGLSubclassFormProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam)
{ TScrGL *scr=(TScrGL*)GetProp(hwnd,"ScrGLSubclass");
  FARPROC OldWndProc=(FARPROC)GetProp(hwnd,"ScrGLOldWndProc");
  if (scr!=NULL) return scr->SubclassFormProc(OldWndProc,hwnd,msg,wParam,lParam);
  if (OldWndProc==NULL) return DefWindowProc(hwnd,msg,wParam,lParam);
  else return CallWindowProc(OldWndProc,hwnd,msg,wParam,lParam);
}
void __fastcall TScrGL::EnterMode()
{ if (hwndSubclass!=NULL) return;
  if (!sglUses3dfxStyle()) return;
  // that's because we only do special handling if it's needed.
  // Note that the ExitMode stuff will get called anyway without this
  // check. That doesn't matter, because it will simply discover that
  // nothing is subclassed and nothing is clipped.
  TCustomForm *f=GetParentForm(this);
  HWND hwnd; if (f==NULL) hwnd=Handle; else hwnd=f->Handle;
  TScrGL *alreadygl=(TScrGL*)GetProp(hwnd,"ScrGLSubclass");
  if (alreadygl!=NULL) return;
  SetProp(hwnd,"ScrGLSubclass",this);
  // we only need to add ourselves into the chain if we are not already there
  LONG AlreadyInChain=(LONG)GetProp(hwnd,"ScrGLOldWndProc");
  if (AlreadyInChain==NULL)
  { LONG OldWndProc=SetWindowLong(hwnd,GWL_WNDPROC,(LONG)ScrGLSubclassFormProc);
    SetProp(hwnd,"ScrGLOldWndProc",(void*)OldWndProc);
  }
  hwndSubclass=hwnd;
  // and the subclass has been installed!
  // Now to clip the mouse
  ClipMouse();
}
void __fastcall TScrGL::ClipMouse()
{ if (FIsMouseClipped) return;
  int sw=GetSystemMetrics(SM_CXSCREEN), sh=GetSystemMetrics(SM_CYSCREEN);
  int cw=Width, ch=Height;
  // First, we'll adjust the mouse coordinate so that it is now in the same
  // place with respect to our window, as it used to be with respect to the screen.
  POINT tl; tl.x=0; tl.y=0; ::ClientToScreen(Handle,&tl);
  POINT pt; GetCursorPos(&pt);
  pt.x=pt.x*cw/sw+tl.x; pt.y=pt.y*ch/sh+tl.y;
  SetCursorPos(pt.x,pt.y);
  // Then we set the clip rectangle to our window
  GetClipCursor(&FOldMouseClip);
  RECT rc; pt.x=0; pt.y=0; POINT pts=ClientToScreen(pt); rc.left=pts.x; rc.top=pts.y;
  pt.x=Width; pt.y=Height; pts=ClientToScreen(pt); rc.right=pts.x; rc.bottom=pts.y;
  ClipCursor(&rc);
  // Finally we adjust speed so that it moves at the same speed with respect to
  // our window as it used to with respect to the screen.
  DWORD param[3]; SystemParametersInfo(SPI_GETMOUSE,0,&param,FALSE); FOldMouseSpeed=param[2];
  param[2]=param[2]*cw/sw; SystemParametersInfo(SPI_SETMOUSE,0,&param,FALSE);
  FIsMouseClipped=true;
}
void __fastcall TScrGL::UnclipMouse()
{ if (!FIsMouseClipped) return;
  int sw=GetSystemMetrics(SM_CXSCREEN), sh=GetSystemMetrics(SM_CYSCREEN);
  int cw=Width, ch=Height;
  // First restore the mouse's speed
  DWORD param[3]; SystemParametersInfo(SPI_GETMOUSE,0,&param,FALSE);
  param[2]=FOldMouseSpeed; SystemParametersInfo(SPI_SETMOUSE,0,&param,FALSE);
  // Then restore its clip rectangle
  ClipCursor(&FOldMouseClip);
  // Finally move it to the same place wrt. the screen as it used to be wrt. the window
  POINT tl; tl.x=0; tl.y=0; ::ClientToScreen(Handle,&tl);
  POINT pt; GetCursorPos(&pt);
  pt.x=(pt.x-tl.x)*sw/cw; pt.y=(pt.y-tl.y)*sh/ch;
  SetCursorPos(pt.x,pt.y);
  FIsMouseClipped=false;
}

void __fastcall TScrGL::ExitMode()
{ UnclipMouse();
  if (FIsSuppressed)
  { Width=FSuppressedWidth; Height=FSuppressedHeight; Align=FSuppressedAlign;
    FIsSuppressed=false;
  }
  HWND hwnd=hwndSubclass;
  if (hwnd==NULL) return;
  TScrGL *alreadyscr=(TScrGL*)GetProp(hwnd,"ScrGLSubclass");
  if (alreadyscr!=this) return; // has been snitched by a different ScrGL!
  LONG prevwndproc=(LONG)GetProp(hwnd,"ScrGLOldWndProc");
  LONG currentwndproc=GetWindowLong(hwnd,GWL_WNDPROC);
  if (currentwndproc==(LONG)ScrGLSubclassFormProc) SetWindowLong(hwnd,GWL_WNDPROC,prevwndproc);
  RemoveProp(hwnd,"ScrGLSubclass");
  if (currentwndproc==(LONG)ScrGLSubclassFormProc) RemoveProp(hwnd,"ScrGLOldWndProc");
  else return; // someone else had hooked into the chain after us
}

void __fastcall TScrGL::InvalidateGLHandle()
{ if (Fhgl==NULL) return;
  sglMakeCurrent(NULL, NULL) ;
  sglDeleteContext(Fhgl);
  Fhgl=NULL;
  ExitMode();
}
void __fastcall TScrGL::GLHandleNeeded()
{ if (GiveUpTrying) return;
  if (Fhgl!=NULL) return;
  HDC hdc=GLCanvasHandle; if (hdc==NULL) return;
  if (FhGLib==NULL) FhGLib=sglLoadLibrary(FGLICD);
  if (FhGLib==NULL) {GiveUpTrying=true;GLError("Error loading library "+FGLICD);return;}
  // Now to suppress the old size. We do this before creating the context,
  // so that by the time we get to sglCreateContext it will know the correct size.
  if (sglUses3dfxStyle() && !FIsSuppressed)
  { FSuppressedWidth=Width; FSuppressedHeight=Height; FSuppressedAlign=Align;
    int w=-1,h=-1;
    switch (FScreenSize)
    { case ss512x384: w=512;h=384;break;
      case ss640x480: w=640;h=480;break;
      case ss800x600: w=800;h=600;break;
      case ss1024x768: w=1024;h=768;break;
    }
    if (w!=-1 && h!=-1)
    { Align=alNone; Width=w; Height=h; FIsSuppressed=true;
    }
  }
  // set up pixel format

  PIXELFORMATDESCRIPTOR pfd; ZeroMemory(&pfd,sizeof(pfd));
  pfd.nSize = sizeof(PIXELFORMATDESCRIPTOR);
  pfd.nVersion = 1;
  pfd.dwFlags=0;
  if (FGLFlags.Contains(f_DOUBLEBUFFER)) pfd.dwFlags |= PFD_DOUBLEBUFFER;
  if (FGLFlags.Contains(f_DRAW_TO_BITMAP)) pfd.dwFlags |= PFD_DRAW_TO_BITMAP;
  if (FGLFlags.Contains(f_DRAW_TO_WINDOW)) pfd.dwFlags |= PFD_DRAW_TO_WINDOW;
  if (FGLFlags.Contains(f_GENERIC_ACCELERATED)) pfd.dwFlags |= PFD_GENERIC_ACCELERATED;
  if (FGLFlags.Contains(f_GENERIC_FORMAT)) pfd.dwFlags |= PFD_GENERIC_FORMAT;
  if (FGLFlags.Contains(f_NEED_PALETTE)) pfd.dwFlags |= PFD_NEED_PALETTE;
  if (FGLFlags.Contains(f_NEED_SYSTEM_PALETTE)) pfd.dwFlags |= PFD_NEED_SYSTEM_PALETTE;
  if (FGLFlags.Contains(f_SUPPORT_GDI)) pfd.dwFlags |= PFD_SUPPORT_GDI;
  if (FGLFlags.Contains(f_SUPPORT_OPENGL)) pfd.dwFlags |= PFD_SUPPORT_OPENGL;
  if (FGLFlags.Contains(f_STEREO)) pfd.dwFlags |= PFD_STEREO;
  if (FGLFlags.Contains(f_SWAP_COPY)) pfd.dwFlags |= PFD_SWAP_COPY;
  if (FGLFlags.Contains(f_SWAP_EXCHANGE)) pfd.dwFlags |= PFD_SWAP_EXCHANGE;
  if (FGLFlags.Contains(f_SWAP_LAYER_BUFFERS)) pfd.dwFlags |= PFD_SWAP_LAYER_BUFFERS;
  if (FGLPixelType==pt_TYPE_RGBA) pfd.iPixelType=PFD_TYPE_RGBA; else pfd.iPixelType=PFD_TYPE_COLORINDEX;
  pfd.cColorBits = FGLColorBits;
  pfd.cDepthBits = FGLDepthBits;
  pfd.dwLayerMask = PFD_MAIN_PLANE;
  pfd.cAccumBits = 0;
  pfd.cStencilBits = 0;
  int pixelformat = sglChoosePixelFormat(hdc,&pfd);
  if (pixelformat==0) {GLError("ChoosePixelFormat failed");return;}
  //ZeroMemory(&pfd,sizeof(pfd)); pfd.nSize=sizeof(pfd); DescribePixelFormat(hdc,pixelformat,sizeof(pfd),&pfd);
  bool res=sglSetPixelFormat(hdc,pixelformat,&pfd);
  if (!res) {GLError("SetPixelFormat failed");return;}
  Fhgl=sglCreateContext(hdc);
  if (Fhgl==NULL) {GLError("Error creating context");return;}
  sglMakeCurrent(hdc,Fhgl);
  if (Color!=clNone)
  { DWORD rgb=ColorToRGB(Color);
    int red=(rgb&0x000000FF)>>0;
    int green=(rgb&0x0000FF00)>>8;
    int blue=(rgb&0x00FF0000)>>16;
    sglClearColor(((float)red)/256.0,((float)green)/256.0,((float)blue)/256.0,0.0);
  }
  EnterMode();
  if (FOnGLInit!=NULL) FOnGLInit(this);
}

HDC __fastcall TScrGL::GetGLCanvasHandle()
{ if (Fhdc!=NULL) return Fhdc;
  Fhdc=GetDC(Handle);
  return Fhdc;
}

bool __fastcall TScrGL::GetIsOn()
{ return (Fhgl!=NULL);
}

void __fastcall TScrGL::GLError(AnsiString s)
{ if (FOnGLError!=NULL) FOnGLError(this,s);
}

void __fastcall TScrGL::SetColor(const TColor c)
{ if (FColor==c) return;
  FColor=c; TWinControl::Color=c;
  if (Color!=clNone && Fhgl!=NULL)
  { DWORD rgb=ColorToRGB(Color);
    int red=(rgb&0x000000FF)>>0;
    int green=(rgb&0x0000FF00)>>8;
    int blue=(rgb&0x00FF0000)>>16;
    sglClearColor(((float)red)/256.0,((float)green)/256.0,((float)blue)/256.0,0.0);
  }
  // For some reason, at design time, using just Repaint or Invalidate
  // didn't end up doing anything. It seemed that the message was being
  // set but the colour didn't change.
  if (HandleAllocated())
  { ::InvalidateRect(Handle,NULL,TRUE);
    UpdateWindow(Handle);
  }
}

void __fastcall TScrGL::SetGLColorBits(const short c)
{ if (FGLColorBits==c) return;
  FGLColorBits=c; InvalidateGLHandle();
}
void __fastcall TScrGL::SetGLDepthBits(const short d)
{ if (FGLDepthBits==d) return;
  FGLDepthBits=d; InvalidateGLHandle();
}
void __fastcall TScrGL::SetGLFlags(const TGLFlags f)
{ if (FGLFlags==f) return;
  FGLFlags=f; InvalidateGLHandle();
}
void __fastcall TScrGL::SetGLPixelType(const TGLPixelType t)
{ if (FGLPixelType==t) return;
  FGLPixelType=t; InvalidateGLHandle();
}

LRESULT __fastcall TScrGL::SubclassFormProc(FARPROC OldWndProc,HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam)
{ if (msg==WM_ACTIVATE)
  { BOOL fActive=LOWORD(wParam);
    if (fActive) ClipMouse(); else UnclipMouse();
  }
  return CallWindowProc(OldWndProc,hwnd,msg,wParam,lParam);
}
void __fastcall TScrGL::WndProc(TMessage &msg)
{ TComponent *test; if (Owner==NULL) test=this; else test=Owner;
  bool des=test->ComponentState.Contains(csDesigning);
  if (des)
  { TWinControl::WndProc(msg);
    return;
  }
  if (msg.Msg==WM_DESTROY)
  { InvalidateGLHandle();
    if (Fhdc!=NULL) ReleaseDC(Handle,Fhdc); Fhdc=NULL;
  }
  if (msg.Msg==WM_SIZE)
  { if (Fhgl==NULL) return;
    sglViewport( 0, 0, Width, Height );
    if (FOnResize!=NULL) FOnResize(this);
  }
  if (msg.Msg==WM_ERASEBKGND) return;
  if (msg.Msg==WM_PAINT)
  { PAINTSTRUCT ps; BeginPaint(Handle,&ps); EndPaint(Handle,&ps);
    GLHandleNeeded();
    if (Fhgl!=NULL)
    { if (Color!=clNone) sglClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
      if (FOnGLPaint!=NULL) FOnGLPaint(this);
      sglSwapBuffers(GLCanvasHandle);
    }
  }
  TWinControl::WndProc(msg);
}





// Code copied from OpenGL.c
// Part of the Plasma Game Server
// written/copyright Ryan Haksi, 1998
// As Ryan says:
//   'If you use this file as part of a publically released project, please
//    grant me the courtesy of a mention in the credits section somewhere.
//    Other than that opengl.h and opengl.c are yours to do with what you wish
//    Current email address(es): cryogen@unix.infoserve.net
//    Current web page address: http://home.bc.rogers.wave.ca/borealis/ryan.html'
// Many thanks to Ryan. Credits to him will duly appear in the about box.


HINSTANCE openglInst = NULL;
BOOL      openglBypassGDI = FALSE;

void            (APIENTRY *fnglAlphaFunc)(GLenum func, GLclampf ref);
void            (APIENTRY *fnglBegin)(GLenum mode);
void            (APIENTRY *fnglBindTexture)(GLenum target, GLuint texture);
void            (APIENTRY *fnglBlendFunc)(GLenum sfactor, GLenum dfactor);
void            (APIENTRY *fnglClear)(GLbitfield mask);
void            (APIENTRY *fnglClearColor)(GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha);
void            (APIENTRY *fnglClearDepth)(GLclampd depth);
void            (APIENTRY *fnglColor3f)(GLfloat red, GLfloat green, GLfloat blue);
void            (APIENTRY *fnglColor3fv)(const GLfloat *v);
void            (APIENTRY *fnglColor4f)(GLfloat red, GLfloat green, GLfloat blue, GLfloat alpha);
void            (APIENTRY *fnglColor4fv)(const GLfloat *v);
void            (APIENTRY *fnglCullFace)(GLenum mode);
void            (APIENTRY *fnglDepthFunc)(GLenum func);
void            (APIENTRY *fnglDisable)(GLenum cap);
void            (APIENTRY *fnglEnable)(GLenum cap);
void            (APIENTRY *fnglEnd)(void);
void            (APIENTRY *fnglFinish)(void);
void            (APIENTRY *fnglFrontFace)(GLenum mode);
void            (APIENTRY *fnglFrustum)(GLdouble left, GLdouble right, GLdouble bottom, GLdouble top, GLdouble zNear, GLdouble zFar);
GLenum          (APIENTRY *fnglGetError)(void);
void            (APIENTRY *fnglGetFloatv)(GLenum pname, GLfloat *params);
void            (APIENTRY *fnglGetIntegerv)(GLenum pname, GLint *params);
const GLubyte * (APIENTRY *fnglGetString)(GLenum name);
void            (APIENTRY *fnglHint)(GLenum target, GLenum mode);
GLboolean       (APIENTRY *fnglIsEnabled)(GLenum cap);
void            (APIENTRY *fnglLoadIdentity)(void);
void            (APIENTRY *fnglLoadMatrixf)(const GLfloat *m);
void            (APIENTRY *fnglMatrixMode)(GLenum mode);
void            (APIENTRY *fnglMultMatrixf)(const GLfloat *m);
void            (APIENTRY *fnglOrtho)(GLdouble left, GLdouble right, GLdouble bottom, GLdouble top, GLdouble zNear, GLdouble zFar);
void            (APIENTRY *fnglPixelStorei)(GLenum pname, GLint param);
void            (APIENTRY *fnglPolygonOffset)(GLfloat factor, GLfloat units);
void            (APIENTRY *fnglPopMatrix)(void);
void            (APIENTRY *fnglPushMatrix)(void);
void            (APIENTRY *fnglRotatef)(GLfloat angle, GLfloat x, GLfloat y, GLfloat z);
void            (APIENTRY *fnglScalef)(GLfloat x, GLfloat y, GLfloat z);
void            (APIENTRY *fnglShadeModel)(GLenum mode);
void            (APIENTRY *fnglTexCoord2f)(GLfloat s, GLfloat t);
void            (APIENTRY *fnglTexCoord2fv)(const GLfloat *v);
void            (APIENTRY *fnglTexCoord3f)(GLfloat s, GLfloat t, GLfloat r);
void            (APIENTRY *fnglTexCoord3fv)(const GLfloat *v);
void            (APIENTRY *fnglTexEnvf)(GLenum target, GLenum pname, GLfloat param);
void            (APIENTRY *fnglTexImage2D)(GLenum target, GLint level, GLint internalformat, GLsizei width, GLsizei height, GLint border, GLenum format, GLenum type, const GLvoid *pixels);
void            (APIENTRY *fnglTexParameterf)(GLenum target, GLenum pname, GLfloat param);
void            (APIENTRY *fnglTranslatef)(GLfloat x, GLfloat y, GLfloat z);
void            (APIENTRY *fnglVertex2f)(GLfloat x, GLfloat y);
void            (APIENTRY *fnglVertex3f)(GLfloat x, GLfloat y, GLfloat z);
void            (APIENTRY *fnglVertex3fv)(const GLfloat *v);
void            (APIENTRY *fnglVertex4f)(GLfloat x, GLfloat y, GLfloat z, GLfloat w);
void            (APIENTRY *fnglViewport)(GLint x, GLint y, GLsizei width, GLsizei height);
void            (APIENTRY *fnglCallList)(GLuint list);
void            (APIENTRY *fnglFlush)(void);
void            (APIENTRY *fnglNewList)(GLuint list, GLenum mode);
void            (APIENTRY *fnglPushName)(GLuint name);
void            (APIENTRY *fnglColor3d)(GLdouble red, GLdouble green, GLdouble blue);
void            (APIENTRY *fnglVertex3d)(GLdouble x, GLdouble y,GLdouble z);
void            (APIENTRY *fnglPopName)(void);
void            (APIENTRY *fnglEndList)(void);
void            (APIENTRY *fnglSelectBuffer)(GLsizei size, GLuint *buffer);
GLint           (APIENTRY *fnglRenderMode)(GLenum mode);
void            (APIENTRY *fnglInitNames)(void);
void            (APIENTRY *fnglGetDoublev)(GLenum pname,GLdouble *params);
void            (APIENTRY *fnglMultMatrixd)(const GLdouble *m);
void            (APIENTRY *fnglTranslated)(GLdouble x, GLdouble y, GLdouble z);
void            (APIENTRY *fnglDeleteLists)(GLuint list,GLsizei range);
GLuint          (APIENTRY *fnglGenLists)(GLsizei range);
void            (APIENTRY *fnglPushAttrib)(GLbitfield mask);
void            (APIENTRY *fnglPopAttrib)(void);
void            (APIENTRY *fnglVertex2i)(GLint x, GLint y);


HGLRC (APIENTRY *fnwglCreateContext)(HDC hdc);
BOOL (APIENTRY *fnwglDeleteContext)(HGLRC hglrc);
BOOL (APIENTRY *fnwglMakeCurrent)(HDC hdc, HGLRC hglrc);
BOOL (APIENTRY *fnwglSwapLayerBuffers)(HDC hdc, UINT fuPlanes);

BOOL (APIENTRY *fnSwapBuffers)(HDC hdc);
int (APIENTRY *fnChoosePixelFormat)(HDC hdc, CONST PIXELFORMATDESCRIPTOR * ppfd);
int (APIENTRY *fnDescribePixelFormat)(HDC hdc, int iPixelFormat, UINT nBytes, LPPIXELFORMATDESCRIPTOR ppfd);
BOOL (APIENTRY *fnSetPixelFormat)(HDC hdc, int iPixelFormat, CONST PIXELFORMATDESCRIPTOR * ppfd);


bool sglUses3dfxStyle()
{ return openglBypassGDI;
}

HINSTANCE sglLoadLibrary(AnsiString fn)
{ // The 3dfxgl.dll minidriver bypasses the GDI entirely
  // Ryan does a proper failover, but the GDI failover call for SwapBuffers is
  // REALLY bloody slow, so best to avoid it alltogether. (when using winglide
  // for debugging Ryan was going from 8 fps to 5fps, thats 37.5%!!!!)
  openglInst = LoadLibrary(fn.c_str());
  if (openglInst == NULL) return NULL;
  openglBypassGDI = (fn.LowerCase().Pos("3dfx")!=0);

  // load all the function pointers
  (void*)fnglAlphaFunc     = GetProcAddress(openglInst, "glAlphaFunc");
  (void*)fnglBegin         = GetProcAddress(openglInst, "glBegin");
  (void*)fnglBindTexture   = GetProcAddress(openglInst, "glBindTexture");
  (void*)fnglBlendFunc     = GetProcAddress(openglInst, "glBlendFunc");
  (void*)fnglClear         = GetProcAddress(openglInst, "glClear");
  (void*)fnglClearColor    = GetProcAddress(openglInst, "glClearColor");
  (void*)fnglClearDepth    = GetProcAddress(openglInst, "glClearDepth");
  (void*)fnglColor3f       = GetProcAddress(openglInst, "glColor3f");
  (void*)fnglColor3fv      = GetProcAddress(openglInst, "glColor3fv");
  (void*)fnglColor4f       = GetProcAddress(openglInst, "glColor4f");
  (void*)fnglColor4fv      = GetProcAddress(openglInst, "glColor4fv");
  (void*)fnglCullFace      = GetProcAddress(openglInst, "glCullFace");
  (void*)fnglDepthFunc     = GetProcAddress(openglInst, "glDepthFunc");
  (void*)fnglDisable       = GetProcAddress(openglInst, "glDisable");
  (void*)fnglEnable        = GetProcAddress(openglInst, "glEnable");
  (void*)fnglEnd           = GetProcAddress(openglInst, "glEnd");
  (void*)fnglFinish        = GetProcAddress(openglInst, "glFinish");
  (void*)fnglFrontFace     = GetProcAddress(openglInst, "glFrontFace");
  (void*)fnglFrustum       = GetProcAddress(openglInst, "glFrustum");
  (void*)fnglGetError      = GetProcAddress(openglInst, "glGetError");
  (void*)fnglGetFloatv     = GetProcAddress(openglInst, "glGetFloatv");
  (void*)fnglGetIntegerv   = GetProcAddress(openglInst, "glGetIntegerv");
  (void*)fnglGetString     = GetProcAddress(openglInst, "glGetString");
  (void*)fnglHint          = GetProcAddress(openglInst, "glHint");
  (void*)fnglIsEnabled     = GetProcAddress(openglInst, "glIsEnabled");
  (void*)fnglLoadIdentity  = GetProcAddress(openglInst, "glLoadIdentity");
  (void*)fnglLoadMatrixf   = GetProcAddress(openglInst, "glLoadMatrixf");
  (void*)fnglMatrixMode    = GetProcAddress(openglInst, "glMatrixMode");
  (void*)fnglMultMatrixf   = GetProcAddress(openglInst, "glMultMatrixf");
  (void*)fnglOrtho         = GetProcAddress(openglInst, "glOrtho");
  (void*)fnglPixelStorei   = GetProcAddress(openglInst, "glPixelStorei");
  (void*)fnglPolygonOffset = GetProcAddress(openglInst, "glPolygonOffset");
  (void*)fnglPopMatrix     = GetProcAddress(openglInst, "glPopMatrix");
  (void*)fnglPushMatrix    = GetProcAddress(openglInst, "glPushMatrix");
  (void*)fnglRotatef       = GetProcAddress(openglInst, "glRotatef");
  (void*)fnglScalef        = GetProcAddress(openglInst, "glScalef");
  (void*)fnglShadeModel    = GetProcAddress(openglInst, "glShadeModel");
  (void*)fnglTexCoord2f    = GetProcAddress(openglInst, "glTexCoord2f");
  (void*)fnglTexCoord2fv   = GetProcAddress(openglInst, "glTexCoord2fv");
  (void*)fnglTexCoord3f    = GetProcAddress(openglInst, "glTexCoord3f");
  (void*)fnglTexCoord3fv   = GetProcAddress(openglInst, "glTexCoord3fv");
  (void*)fnglTexEnvf       = GetProcAddress(openglInst, "glTexEnvf");
  (void*)fnglTexImage2D    = GetProcAddress(openglInst, "glTexImage2D");
  (void*)fnglTexParameterf = GetProcAddress(openglInst, "glTexParameterf");
  (void*)fnglTranslatef    = GetProcAddress(openglInst, "glTranslatef");
  (void*)fnglVertex2f      = GetProcAddress(openglInst, "glVertex2f");
  (void*)fnglVertex3f      = GetProcAddress(openglInst, "glVertex3f");
  (void*)fnglVertex3fv     = GetProcAddress(openglInst, "glVertex3fv");
  (void*)fnglVertex4f      = GetProcAddress(openglInst, "glVertex4f");
  (void*)fnglViewport      = GetProcAddress(openglInst, "glViewport");
  (void*)fnglCallList      = GetProcAddress(openglInst, "glCallList");
  (void*)fnglFlush         = GetProcAddress(openglInst, "glFlush");
  (void*)fnglNewList       = GetProcAddress(openglInst, "glNewList");
  (void*)fnglPushName      = GetProcAddress(openglInst, "glPushName");
  (void*)fnglColor3d       = GetProcAddress(openglInst, "glColor3d");
  (void*)fnglVertex3d      = GetProcAddress(openglInst, "glVertex3d");
  (void*)fnglPopName       = GetProcAddress(openglInst, "glPopName");
  (void*)fnglEndList       = GetProcAddress(openglInst, "glEndList");
  (void*)fnglSelectBuffer  = GetProcAddress(openglInst, "glSelectBuffer");
  (void*)fnglRenderMode    = GetProcAddress(openglInst, "glRenderMode");
  (void*)fnglInitNames     = GetProcAddress(openglInst, "glInitNames");
  (void*)fnglGetDoublev    = GetProcAddress(openglInst, "glGetDoublev");
  (void*)fnglMultMatrixd   = GetProcAddress(openglInst, "glMultMatrixd");
  (void*)fnglTranslated    = GetProcAddress(openglInst, "glTranslated");
  (void*)fnglDeleteLists   = GetProcAddress(openglInst, "glDeleteLists");
  (void*)fnglGenLists      = GetProcAddress(openglInst, "glGenLists");
  (void*)fnglPushAttrib    = GetProcAddress(openglInst, "glPushAttrib");
  (void*)fnglPopAttrib     = GetProcAddress(openglInst, "glPopAttrib");
  (void*)fnglVertex2i      = GetProcAddress(openglInst, "glVertex2i");
  //
  (void*)fnwglCreateContext = GetProcAddress(openglInst, "wglCreateContext");
  (void*)fnwglDeleteContext = GetProcAddress(openglInst, "wglDeleteContext");
  (void*)fnwglMakeCurrent = GetProcAddress(openglInst, "wglMakeCurrent");
  (void*)fnwglSwapLayerBuffers = GetProcAddress(openglInst, "wglSwapLayerBuffers");
  //
  (void*)fnSwapBuffers = GetProcAddress(openglInst, "wglSwapBuffers");
  (void*)fnChoosePixelFormat = GetProcAddress(openglInst, "wglChoosePixelFormat");
  (void*)fnDescribePixelFormat = GetProcAddress(openglInst, "wglDescribePixelFormat");
  (void*)fnSetPixelFormat = GetProcAddress(openglInst, "wglSetPixelFormat");
  //
  bool succ=true;
  // *** Must change this to allow pass if we've defined minigl
  if (fnglAlphaFunc==NULL) succ=false;
  if (fnglBegin==NULL) succ=false;
  if (fnglBindTexture==NULL) succ=false;
  if (fnglBlendFunc==NULL) succ=false;
  if (fnglClear==NULL) succ=false;
  if (fnglClearColor==NULL) succ=false;
  if (fnglClearDepth==NULL) succ=false;
  if (fnglColor3f==NULL) succ=false;
  if (fnglColor3fv==NULL) succ=false;
  if (fnglColor4f==NULL) succ=false;
  if (fnglColor4fv==NULL) succ=false;
  if (fnglCullFace==NULL) succ=false;
  if (fnglDepthFunc==NULL) succ=false;
  if (fnglDisable==NULL) succ=false;
  if (fnglEnable==NULL) succ=false;
  if (fnglEnd           ==NULL) succ=false;
  if (fnglFinish        ==NULL) succ=false;
  if (fnglFrontFace     ==NULL) succ=false;
  if (fnglFrustum       ==NULL) succ=false;
  if (fnglGetError      ==NULL) succ=false;
  if (fnglGetFloatv     ==NULL) succ=false;
  if (fnglGetIntegerv   ==NULL) succ=false;
  if (fnglGetString==NULL) succ=false;
  if (fnglHint==NULL) succ=false;
  if (fnglIsEnabled==NULL) succ=false;
  if (fnglLoadIdentity==NULL) succ=false;
  if (fnglLoadMatrixf==NULL) succ=false;
  if (fnglMatrixMode==NULL) succ=false;
  if (fnglMultMatrixf==NULL) succ=false;
  if (fnglOrtho==NULL) succ=false;
  if (fnglPixelStorei==NULL) succ=false;
  if (fnglPolygonOffset==NULL) succ=false;
  if (fnglPopMatrix==NULL) succ=false;
  if (fnglPushMatrix==NULL) succ=false;
  if (fnglRotatef==NULL) succ=false;
  if (fnglScalef==NULL) succ=false;
  if (fnglShadeModel==NULL) succ=false;
  if (fnglTexCoord2f==NULL) succ=false;
  if (fnglTexCoord2fv==NULL) succ=false;
  if (fnglTexCoord3f==NULL) succ=false;
  if (fnglTexCoord3fv==NULL) succ=false;
  if (fnglTexEnvf==NULL) succ=false;
  if (fnglTexImage2D==NULL) succ=false;
  if (fnglTexParameterf==NULL) succ=false;
  if (fnglTranslatef==NULL) succ=false;
  if (fnglVertex2f==NULL) succ=false;
  if (fnglVertex3f==NULL) succ=false;
  if (fnglVertex3fv==NULL) succ=false;
  if (fnglVertex4f==NULL) succ=false;
  if (fnglViewport==NULL) succ=false;
  if (fnglCallList==NULL) succ=false;
  if (fnglFlush==NULL) succ=false;
  if (fnglNewList==NULL) succ=false;
  if (fnglPushName==NULL) succ=false;
  if (fnglColor3d==NULL) succ=false;
  if (fnglVertex3d==NULL) succ=false;
  if (fnglPopName==NULL) succ=false;
  if (fnglEndList==NULL) succ=false;
  if (fnglSelectBuffer==NULL) succ=false;
  if (fnglRenderMode==NULL) succ=false;
  if (fnglInitNames==NULL) succ=false;
  if (fnglGetDoublev==NULL) succ=false;
  if (fnglMultMatrixd==NULL) succ=false;
  if (fnglTranslated==NULL) succ=false;
  if (fnglDeleteLists==NULL) succ=false;
  if (fnglGenLists==NULL) succ=false;
  if (fnglPushAttrib==NULL) succ=false;
  if (fnglPopAttrib==NULL) succ=false;
  if (fnglVertex2i==NULL) succ=false;
  //
  if (fnwglCreateContext==NULL) succ=false;
  if (fnwglDeleteContext==NULL) succ=false;
  if (fnwglMakeCurrent==NULL) succ=false;
  if (fnwglSwapLayerBuffers==NULL) succ=false;
  // And the windows functions we won't complain about, since
  // we'll generally be calling the Windows API versions of these first.
  // SwapBuffers, ChoosePixelFormat, DescribePixelFormat, SetPixelFormat
  if (!succ) {FreeLibrary(openglInst);openglInst=NULL;return NULL;}

  return openglInst;
}

void sglFreeLibrary(HINSTANCE h)
{ if (openglInst!=NULL) FreeLibrary(openglInst);
  openglInst = NULL;
}



void PACKAGE APIENTRY sglAlphaFunc(GLenum func, GLclampf ref)         {(*fnglAlphaFunc)(func,ref);}
void PACKAGE APIENTRY sglBegin(GLenum mode)                           {(*fnglBegin)(mode);}
void PACKAGE APIENTRY sglBindTexture(GLenum target, GLuint texture)   {(*fnglBindTexture)(target,texture);}
void PACKAGE APIENTRY sglBlendFunc(GLenum sfactor, GLenum dfactor)    {(*fnglBlendFunc)(sfactor,dfactor);}
void PACKAGE APIENTRY sglClear(GLbitfield mask)                       {(*fnglClear)(mask);}
void PACKAGE APIENTRY sglClearColor (GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha){(*fnglClearColor)(red,green,blue,alpha);}
void PACKAGE APIENTRY sglClearDepth (GLclampd depth)                  {(*fnglClearDepth)(depth);}
void PACKAGE APIENTRY sglColor3f(GLfloat red, GLfloat green, GLfloat blue) {(*fnglColor3f)(red,green,blue);}
void PACKAGE APIENTRY sglColor3fv(const GLfloat *v)                   {(*fnglColor3fv)(v);}
void PACKAGE APIENTRY sglColor4f(GLfloat red, GLfloat green, GLfloat blue, GLfloat alpha) {(*fnglColor4f)(red,green,blue,alpha);}
void PACKAGE APIENTRY sglColor4fv(const GLfloat *v)                   {(*fnglColor4fv)(v);}
void PACKAGE APIENTRY sglCullFace(GLenum mode)                        {(*fnglCullFace)(mode);}
void PACKAGE APIENTRY sglDepthFunc(GLenum func)                       {(*fnglDepthFunc)(func);}
void PACKAGE APIENTRY sglDisable(GLenum cap)                          {(*fnglDisable)(cap);}
void PACKAGE APIENTRY sglEnable(GLenum cap)                           {(*fnglEnable)(cap);}
void PACKAGE APIENTRY sglEnd(void)                                    {(*fnglEnd)();}
void PACKAGE APIENTRY sglFinish(void)                                 {(*fnglFinish)();}
void PACKAGE APIENTRY sglFrontFace(GLenum mode)                       {(*fnglFrontFace)(mode);}
void PACKAGE APIENTRY sglFrustum(GLdouble left, GLdouble right, GLdouble bottom, GLdouble top, GLdouble zNear, GLdouble zFar) {(*fnglFrustum)(left,right,bottom,top,zNear,zFar);}
GLenum PACKAGE APIENTRY sglGetError(void)                             {return (*fnglGetError)();}
void PACKAGE APIENTRY sglGetFloatv(GLenum pname, GLfloat *params)     {(*fnglGetFloatv)(pname, params);}
void PACKAGE APIENTRY sglGetIntegerv(GLenum pname, GLint *params)     {(*fnglGetIntegerv)(pname,params);}
const GLubyte * PACKAGE APIENTRY sglGetString(GLenum name)            {return (*fnglGetString)(name);}
void PACKAGE APIENTRY sglHint(GLenum target, GLenum mode)             {(*fnglHint)(target,mode);}
GLboolean PACKAGE APIENTRY sglIsEnabled(GLenum cap)                   {return (*fnglIsEnabled)(cap);}
void PACKAGE APIENTRY sglLoadIdentity(void)                           {(*fnglLoadIdentity)();}
void PACKAGE APIENTRY sglLoadMatrixf(const GLfloat *m)                {(*fnglLoadMatrixf)(m);}
void PACKAGE APIENTRY sglMatrixMode(GLenum mode)                      {(*fnglMatrixMode)(mode);}
void PACKAGE APIENTRY sglMultMatrixf(const GLfloat *m)                {(*fnglMultMatrixf)(m);}
void PACKAGE APIENTRY sglOrtho(GLdouble left, GLdouble right, GLdouble bottom, GLdouble top, GLdouble zNear, GLdouble zFar) {(*fnglOrtho)(left,right,bottom,top,zNear,zFar);}
void PACKAGE APIENTRY sglPixelStorei (GLenum pname, GLint param)      {(*fnglPixelStorei)(pname, param);}
void PACKAGE APIENTRY sglPolygonOffset(GLfloat factor, GLfloat units) {(*fnglPolygonOffset)(factor,units);}
void PACKAGE APIENTRY sglPopMatrix(void)                              {(*fnglPopMatrix)();}
void PACKAGE APIENTRY sglPushMatrix(void)                             {(*fnglPushMatrix)();}
void PACKAGE APIENTRY sglRotatef(GLfloat angle, GLfloat x, GLfloat y, GLfloat z) {(*fnglRotatef)(angle,x,y,z);}
void PACKAGE APIENTRY sglScalef(GLfloat x, GLfloat y, GLfloat z)      {(*fnglScalef)(x,y,z);}
void PACKAGE APIENTRY sglShadeModel (GLenum mode)                     {(*fnglShadeModel)(mode);}
void PACKAGE APIENTRY sglTexCoord2f(GLfloat s, GLfloat t)             {(*fnglTexCoord2f)(s,t);}
void PACKAGE APIENTRY sglTexCoord2fv(const GLfloat *v)                {(*fnglTexCoord2fv)(v);}
void PACKAGE APIENTRY sglTexCoord3f(GLfloat s, GLfloat t, GLfloat r)  {(*fnglTexCoord3f)(s,t,r);}
void PACKAGE APIENTRY sglTexCoord3fv(const GLfloat *v)                {(*fnglTexCoord3fv)(v);}
void PACKAGE APIENTRY sglTexEnvf(GLenum target, GLenum pname, GLfloat param) {(*fnglTexEnvf)(target,pname,param);}
void PACKAGE APIENTRY sglTexImage2D(GLenum target, GLint level, GLint internalformat, GLsizei width, GLsizei height, GLint border, GLenum format, GLenum type, const GLvoid *pixels) {(*fnglTexImage2D)(target,level,internalformat,width,height,border,format,type,pixels);}
void PACKAGE APIENTRY sglTexParameterf(GLenum target, GLenum pname, GLfloat param) {(*fnglTexParameterf)(target,pname,param);}
void PACKAGE APIENTRY sglTranslatef(GLfloat x, GLfloat y, GLfloat z)  {(*fnglTranslatef)(x,y,z);}
void PACKAGE APIENTRY sglVertex2f(GLfloat x, GLfloat y)               {(*fnglVertex2f)(x,y);}
void PACKAGE APIENTRY sglVertex3f(GLfloat x, GLfloat y, GLfloat z)    {(*fnglVertex3f)(x,y,z);}
void PACKAGE APIENTRY sglVertex3fv(const GLfloat *v)                  {(*fnglVertex3fv)(v);}
void PACKAGE APIENTRY sglVertex4f(GLfloat x, GLfloat y, GLfloat z, GLfloat w) {(*fnglVertex4f)(x,y,z,w);}
void PACKAGE APIENTRY sglViewport(GLint x, GLint y, GLsizei width, GLsizei height) {(*fnglViewport)(x,y,width,height);}
// LJW:
void PACKAGE APIENTRY sglCallList(GLuint list)                        {(*fnglCallList)(list);}
void PACKAGE APIENTRY sglFlush()                                      {(*fnglFlush)();}
void PACKAGE APIENTRY sglNewList(GLuint list,GLenum mode)             {(*fnglNewList)(list,mode);}
void PACKAGE APIENTRY sglPushName(GLuint name)                        {(*fnglPushName)(name);}
void PACKAGE APIENTRY sglColor3d(GLdouble red, GLdouble green, GLdouble blue) {(*fnglColor3d)(red,green,blue);}
void PACKAGE APIENTRY sglVertex3d(GLdouble x, GLdouble y,GLdouble z)  {(*fnglVertex3d)(x,y,z);}
void PACKAGE APIENTRY sglPopName()                                    {(*fnglPopName)();}
void PACKAGE APIENTRY sglEndList()                                    {(*fnglEndList)();}
void PACKAGE APIENTRY sglSelectBuffer(GLsizei size, GLuint *buffer)   {(*fnglSelectBuffer)(size,buffer);}
GLint PACKAGE APIENTRY sglRenderMode(GLenum mode)                     {return (*fnglRenderMode)(mode);}
void PACKAGE APIENTRY sglInitNames()                                  {(*fnglInitNames)();}
void PACKAGE APIENTRY sglGetDoublev(GLenum pname,GLdouble *params)    {(*fnglGetDoublev)(pname,params);}
void PACKAGE APIENTRY sglMultMatrixd(const GLdouble *m)               {(*fnglMultMatrixd)(m);}
void PACKAGE APIENTRY sglTranslated(GLdouble x, GLdouble y, GLdouble z) {(*fnglTranslated)(x,y,z);}
void PACKAGE APIENTRY sglDeleteLists(GLuint list,GLsizei range)       {(*fnglDeleteLists)(list,range);}
GLuint PACKAGE APIENTRY sglGenLists(GLsizei range)                    {return (*fnglGenLists)(range);}
void PACKAGE APIENTRY sglPushAttrib(GLbitfield mask)                  {(*fnglPushAttrib)(mask);}
void PACKAGE APIENTRY sglPopAttrib()                                  {(*fnglPopAttrib)();}
void PACKAGE APIENTRY sglVertex2i(GLint x, GLint y)                   {(*fnglVertex2i)(x,y);}






// These are wgl functions
HGLRC PACKAGE APIENTRY sglCreateContext(HDC hdc)                     {return (*fnwglCreateContext)(hdc);}
BOOL PACKAGE APIENTRY sglDeleteContext(HGLRC hglrc)                  {return (*fnwglDeleteContext)(hglrc);}
BOOL PACKAGE APIENTRY sglMakeCurrent(HDC hdc, HGLRC hglrc)           {return (*fnwglMakeCurrent)(hdc, hglrc);}
BOOL PACKAGE APIENTRY sglSwapLayerBuffers(HDC hdc, UINT fuPlanes)    {return (*fnwglSwapLayerBuffers)(hdc, fuPlanes);}

// These are windows functions. SwapBuffers is specially optimised not to call GDI
BOOL PACKAGE APIENTRY sglSwapBuffers(HDC hdc)
{ if (!openglBypassGDI) {int retValue=SwapBuffers(hdc); if (retValue) return retValue;}
  if (!openglInst || !fnSwapBuffers) return FALSE; else return (*fnSwapBuffers)(hdc);
}
int PACKAGE APIENTRY sglChoosePixelFormat(HDC hdc, CONST PIXELFORMATDESCRIPTOR * ppfd)
{ int retValue=ChoosePixelFormat(hdc, ppfd); if (retValue) return retValue;
  if (!openglInst || !fnChoosePixelFormat) return FALSE; else return (*fnChoosePixelFormat)(hdc, ppfd);
}
int PACKAGE APIENTRY sglDescribePixelFormat(HDC hdc, int iPixelFormat, UINT nBytes, LPPIXELFORMATDESCRIPTOR ppfd)
{ int retValue = DescribePixelFormat(hdc, iPixelFormat, nBytes, ppfd); if (retValue) return retValue;
  if (!openglInst || !fnDescribePixelFormat) return FALSE; else return (*fnDescribePixelFormat)(hdc, iPixelFormat, nBytes, ppfd);
}
BOOL PACKAGE APIENTRY sglSetPixelFormat(HDC hdc, int iPixelFormat, CONST PIXELFORMATDESCRIPTOR * ppfd)
{ int retValue=SetPixelFormat(hdc, iPixelFormat, ppfd); if (retValue) return retValue;
  if (!openglInst || !fnSetPixelFormat) return FALSE; else return (*fnSetPixelFormat)(hdc, iPixelFormat, ppfd);
}





// The code for these sglu* functions comes from Mesa.
// Their inclusion in here forces ScrGL to be a gnu library license thing.
// If you don't want the license, then you must delete these from the code.

void PACKAGE APIENTRY sgluOrtho2D( GLdouble left, GLdouble right,
                          GLdouble bottom, GLdouble top )
{
   sglOrtho( left, right, bottom, top, -1.0, 1.0 );
}


void PACKAGE APIENTRY sgluLookAt( GLdouble eyex, GLdouble eyey, GLdouble eyez,
                         GLdouble centerx, GLdouble centery, GLdouble centerz,
                         GLdouble upx, GLdouble upy, GLdouble upz )
{
   GLdouble m[16];
   GLdouble x[3], y[3], z[3];
   GLdouble mag;

   /* Make rotation matrix */

   /* Z vector */
   z[0] = eyex - centerx;
   z[1] = eyey - centery;
   z[2] = eyez - centerz;
   mag = sqrt( z[0]*z[0] + z[1]*z[1] + z[2]*z[2] );
   if (mag) {  /* mpichler, 19950515 */
      z[0] /= mag;
      z[1] /= mag;
      z[2] /= mag;
   }

   /* Y vector */
   y[0] = upx;
   y[1] = upy;
   y[2] = upz;

   /* X vector = Y cross Z */
   x[0] =  y[1]*z[2] - y[2]*z[1];
   x[1] = -y[0]*z[2] + y[2]*z[0];
   x[2] =  y[0]*z[1] - y[1]*z[0];

   /* Recompute Y = Z cross X */
   y[0] =  z[1]*x[2] - z[2]*x[1];
   y[1] = -z[0]*x[2] + z[2]*x[0];
   y[2] =  z[0]*x[1] - z[1]*x[0];

   /* mpichler, 19950515 */
   /* cross product gives area of parallelogram, which is < 1.0 for
    * non-perpendicular unit-length vectors; so normalize x, y here
    */

   mag = sqrt( x[0]*x[0] + x[1]*x[1] + x[2]*x[2] );
   if (mag) {
      x[0] /= mag;
      x[1] /= mag;
      x[2] /= mag;
   }

   mag = sqrt( y[0]*y[0] + y[1]*y[1] + y[2]*y[2] );
   if (mag) {
      y[0] /= mag;
      y[1] /= mag;
      y[2] /= mag;
   }

#define M(row,col)  m[col*4+row]
   M(0,0) = x[0];  M(0,1) = x[1];  M(0,2) = x[2];  M(0,3) = 0.0;
   M(1,0) = y[0];  M(1,1) = y[1];  M(1,2) = y[2];  M(1,3) = 0.0;
   M(2,0) = z[0];  M(2,1) = z[1];  M(2,2) = z[2];  M(2,3) = 0.0;
   M(3,0) = 0.0;   M(3,1) = 0.0;   M(3,2) = 0.0;   M(3,3) = 1.0;
#undef M
   sglMultMatrixd( m );

   /* Translate Eye to Origin */
   sglTranslated( -eyex, -eyey, -eyez );

}




void PACKAGE APIENTRY sgluPerspective( GLdouble fovy, GLdouble aspect,
                              GLdouble zNear, GLdouble zFar )
{
   GLdouble xmin, xmax, ymin, ymax;

   ymax = zNear * tan( fovy * M_PI / 360.0 );
   ymin = -ymax;

   xmin = ymin * aspect;
   xmax = ymax * aspect;

   sglFrustum( xmin, xmax, ymin, ymax, zNear, zFar );
}



void PACKAGE APIENTRY sgluPickMatrix( GLdouble x, GLdouble y,
                             GLdouble width, GLdouble height,
                             const GLint viewport[4] )
{
   GLfloat m[16];
   GLfloat sx, sy;
   GLfloat tx, ty;

   sx = viewport[2] / width;
   sy = viewport[3] / height;
   tx = (viewport[2] + 2.0 * (viewport[0] - x)) / width;
   ty = (viewport[3] + 2.0 * (viewport[1] - y)) / height;

#define M(row,col)  m[col*4+row]
   M(0,0) = sx;   M(0,1) = 0.0;  M(0,2) = 0.0;  M(0,3) = tx;
   M(1,0) = 0.0;  M(1,1) = sy;   M(1,2) = 0.0;  M(1,3) = ty;
   M(2,0) = 0.0;  M(2,1) = 0.0;  M(2,2) = 1.0;  M(2,3) = 0.0;
   M(3,0) = 0.0;  M(3,1) = 0.0;  M(3,2) = 0.0;  M(3,3) = 1.0;
#undef M

   sglMultMatrixf( m );
}



/*
 * Perform a 4x4 matrix multiplication  (product = a x b).
 * Input:  a, b - matrices to multiply
 * Output:  product - product of a and b
 */
static void matmul( GLdouble *product, const GLdouble *a, const GLdouble *b )
{
   /* This matmul was contributed by Thomas Malik */
   GLdouble temp[16];
   GLint i;

#define A(row,col)  a[(col<<2)+row]
#define B(row,col)  b[(col<<2)+row]
#define T(row,col)  temp[(col<<2)+row]

   /* i-te Zeile */
   for (i = 0; i < 4; i++)
     {
	T(i, 0) = A(i, 0) * B(0, 0) + A(i, 1) * B(1, 0) + A(i, 2) * B(2, 0) + A(i, 3) * B(3, 0);
	T(i, 1) = A(i, 0) * B(0, 1) + A(i, 1) * B(1, 1) + A(i, 2) * B(2, 1) + A(i, 3) * B(3, 1);
	T(i, 2) = A(i, 0) * B(0, 2) + A(i, 1) * B(1, 2) + A(i, 2) * B(2, 2) + A(i, 3) * B(3, 2);
	T(i, 3) = A(i, 0) * B(0, 3) + A(i, 1) * B(1, 3) + A(i, 2) * B(2, 3) + A(i, 3) * B(3, 3);
     }

#undef A
#undef B
#undef T
   memcpy( product, temp, 16*sizeof(GLdouble) );
}

/*
 * Compute inverse of 4x4 transformation matrix.
 * Code contributed by Jacques Leroy jle@star.be
 * Return GL_TRUE for success, GL_FALSE for failure (singular matrix)
 */
static GLboolean invert_matrix( const GLdouble *m, GLdouble *out )
{
/* NB. OpenGL Matrices are COLUMN major. */
#define SWAP_ROWS(a, b) { GLdouble *_tmp = a; (a)=(b); (b)=_tmp; }
#define MAT(m,r,c) (m)[(c)*4+(r)]

 GLdouble wtmp[4][8];
 GLdouble m0, m1, m2, m3, s;
 GLdouble *r0, *r1, *r2, *r3;

 r0 = wtmp[0], r1 = wtmp[1], r2 = wtmp[2], r3 = wtmp[3];

 r0[0] = MAT(m,0,0), r0[1] = MAT(m,0,1),
 r0[2] = MAT(m,0,2), r0[3] = MAT(m,0,3),
 r0[4] = 1.0, r0[5] = r0[6] = r0[7] = 0.0,

 r1[0] = MAT(m,1,0), r1[1] = MAT(m,1,1),
 r1[2] = MAT(m,1,2), r1[3] = MAT(m,1,3),
 r1[5] = 1.0, r1[4] = r1[6] = r1[7] = 0.0,

 r2[0] = MAT(m,2,0), r2[1] = MAT(m,2,1),
 r2[2] = MAT(m,2,2), r2[3] = MAT(m,2,3),
 r2[6] = 1.0, r2[4] = r2[5] = r2[7] = 0.0,

 r3[0] = MAT(m,3,0), r3[1] = MAT(m,3,1),
 r3[2] = MAT(m,3,2), r3[3] = MAT(m,3,3),
 r3[7] = 1.0, r3[4] = r3[5] = r3[6] = 0.0;

 /* choose pivot - or die */
 if (fabs(r3[0])>fabs(r2[0])) SWAP_ROWS(r3, r2);
 if (fabs(r2[0])>fabs(r1[0])) SWAP_ROWS(r2, r1);
 if (fabs(r1[0])>fabs(r0[0])) SWAP_ROWS(r1, r0);
 if (0.0 == r0[0])  return GL_FALSE;

 /* eliminate first variable     */
 m1 = r1[0]/r0[0]; m2 = r2[0]/r0[0]; m3 = r3[0]/r0[0];
 s = r0[1]; r1[1] -= m1 * s; r2[1] -= m2 * s; r3[1] -= m3 * s;
 s = r0[2]; r1[2] -= m1 * s; r2[2] -= m2 * s; r3[2] -= m3 * s;
 s = r0[3]; r1[3] -= m1 * s; r2[3] -= m2 * s; r3[3] -= m3 * s;
 s = r0[4];
 if (s != 0.0) { r1[4] -= m1 * s; r2[4] -= m2 * s; r3[4] -= m3 * s; }
 s = r0[5];
 if (s != 0.0) { r1[5] -= m1 * s; r2[5] -= m2 * s; r3[5] -= m3 * s; }
 s = r0[6];
 if (s != 0.0) { r1[6] -= m1 * s; r2[6] -= m2 * s; r3[6] -= m3 * s; }
 s = r0[7];
 if (s != 0.0) { r1[7] -= m1 * s; r2[7] -= m2 * s; r3[7] -= m3 * s; }

 /* choose pivot - or die */
 if (fabs(r3[1])>fabs(r2[1])) SWAP_ROWS(r3, r2);
 if (fabs(r2[1])>fabs(r1[1])) SWAP_ROWS(r2, r1);
 if (0.0 == r1[1])  return GL_FALSE;

 /* eliminate second variable */
 m2 = r2[1]/r1[1]; m3 = r3[1]/r1[1];
 r2[2] -= m2 * r1[2]; r3[2] -= m3 * r1[2];
 r2[3] -= m2 * r1[3]; r3[3] -= m3 * r1[3];
 s = r1[4]; if (0.0 != s) { r2[4] -= m2 * s; r3[4] -= m3 * s; }
 s = r1[5]; if (0.0 != s) { r2[5] -= m2 * s; r3[5] -= m3 * s; }
 s = r1[6]; if (0.0 != s) { r2[6] -= m2 * s; r3[6] -= m3 * s; }
 s = r1[7]; if (0.0 != s) { r2[7] -= m2 * s; r3[7] -= m3 * s; }

 /* choose pivot - or die */
 if (fabs(r3[2])>fabs(r2[2])) SWAP_ROWS(r3, r2);
 if (0.0 == r2[2])  return GL_FALSE;

 /* eliminate third variable */
 m3 = r3[2]/r2[2];
 r3[3] -= m3 * r2[3], r3[4] -= m3 * r2[4],
 r3[5] -= m3 * r2[5], r3[6] -= m3 * r2[6],
 r3[7] -= m3 * r2[7];

 /* last check */
 if (0.0 == r3[3]) return GL_FALSE;

 s = 1.0/r3[3];              /* now back substitute row 3 */
 r3[4] *= s; r3[5] *= s; r3[6] *= s; r3[7] *= s;

 m2 = r2[3];                 /* now back substitute row 2 */
 s  = 1.0/r2[2];
 r2[4] = s * (r2[4] - r3[4] * m2), r2[5] = s * (r2[5] - r3[5] * m2),
 r2[6] = s * (r2[6] - r3[6] * m2), r2[7] = s * (r2[7] - r3[7] * m2);
 m1 = r1[3];
 r1[4] -= r3[4] * m1, r1[5] -= r3[5] * m1,
 r1[6] -= r3[6] * m1, r1[7] -= r3[7] * m1;
 m0 = r0[3];
 r0[4] -= r3[4] * m0, r0[5] -= r3[5] * m0,
 r0[6] -= r3[6] * m0, r0[7] -= r3[7] * m0;

 m1 = r1[2];                 /* now back substitute row 1 */
 s  = 1.0/r1[1];
 r1[4] = s * (r1[4] - r2[4] * m1), r1[5] = s * (r1[5] - r2[5] * m1),
 r1[6] = s * (r1[6] - r2[6] * m1), r1[7] = s * (r1[7] - r2[7] * m1);
 m0 = r0[2];
 r0[4] -= r2[4] * m0, r0[5] -= r2[5] * m0,
 r0[6] -= r2[6] * m0, r0[7] -= r2[7] * m0;

 m0 = r0[1];                 /* now back substitute row 0 */
 s  = 1.0/r0[0];
 r0[4] = s * (r0[4] - r1[4] * m0), r0[5] = s * (r0[5] - r1[5] * m0),
 r0[6] = s * (r0[6] - r1[6] * m0), r0[7] = s * (r0[7] - r1[7] * m0);

 MAT(out,0,0) = r0[4]; MAT(out,0,1) = r0[5],
 MAT(out,0,2) = r0[6]; MAT(out,0,3) = r0[7],
 MAT(out,1,0) = r1[4]; MAT(out,1,1) = r1[5],
 MAT(out,1,2) = r1[6]; MAT(out,1,3) = r1[7],
 MAT(out,2,0) = r2[4]; MAT(out,2,1) = r2[5],
 MAT(out,2,2) = r2[6]; MAT(out,2,3) = r2[7],
 MAT(out,3,0) = r3[4]; MAT(out,3,1) = r3[5],
 MAT(out,3,2) = r3[6]; MAT(out,3,3) = r3[7];

 return GL_TRUE;

#undef MAT
#undef SWAP_ROWS
}


/*
 * Transform a point (column vector) by a 4x4 matrix.  I.e.  out = m * in
 * Input:  m - the 4x4 matrix
 *         in - the 4x1 vector
 * Output:  out - the resulting 4x1 vector.
 */
static void transform_point( GLdouble out[4], const GLdouble m[16],
			     const GLdouble in[4] )
{
#define M(row,col)  m[col*4+row]
   out[0] = M(0,0) * in[0] + M(0,1) * in[1] + M(0,2) * in[2] + M(0,3) * in[3];
   out[1] = M(1,0) * in[0] + M(1,1) * in[1] + M(1,2) * in[2] + M(1,3) * in[3];
   out[2] = M(2,0) * in[0] + M(2,1) * in[1] + M(2,2) * in[2] + M(2,3) * in[3];
   out[3] = M(3,0) * in[0] + M(3,1) * in[1] + M(3,2) * in[2] + M(3,3) * in[3];
#undef M
}


/* transformation du point ecran (winx,winy,winz) en point objet */
GLint PACKAGE APIENTRY sgluUnProject(GLdouble winx,GLdouble winy,GLdouble winz,
                            const GLdouble model[16],const GLdouble proj[16],
                            const GLint viewport[4],
                            GLdouble *objx,GLdouble *objy,GLdouble *objz)
{
    /* matrice de transformation */
    GLdouble m[16], A[16];
    GLdouble in[4],out[4];

    /* transformation coordonnees normalisees entre -1 et 1 */
    in[0]=(winx-viewport[0])*2/viewport[2] - 1.0;
    in[1]=(winy-viewport[1])*2/viewport[3] - 1.0;
    in[2]=2*winz - 1.0;
    in[3]=1.0;

    /* calcul transformation inverse */
    matmul(A,proj,model);
    invert_matrix(A,m);

    /* d'ou les coordonnees objets */
    transform_point(out,m,in);
    if (out[3]==0.0)
       return GL_FALSE;
    *objx=out[0]/out[3];
    *objy=out[1]/out[3];
    *objz=out[2]/out[3];
    return GL_TRUE;
}







//---------------------------------------------------------------------------
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void*) {return 1;}
namespace Scrgl
{ void __fastcall PACKAGE Register()
  { TComponentClass classes[] = {__classid(TScrGL),
                                 __classid(TGLICDList)};
    RegisterComponents("ScrPlus",classes,(sizeof(classes)/sizeof(classes[0]))-1);
  }
}
